#!/bin/sh

###############################################
# script: install.sh                          #
###############################################
# author: rung  2011                          #
# web: http://rung.narod.ru                   #
# contact: Email: rung@narod.ru               #
# Version: 12.5 - 13.5 (__/__/2011)           #
# ------------------------------------------  #
# author: valerakvb (c) 2009                  #
# contact: http://pc-help.homedns.org         #
# Version: 1.1 (04.11.09) - 12.4 (09/07/2010) #
###############################################

: << COMMENT
unset

COMMENT

number_ver="13.5"
h_address_url="http://rung.narod.ru"
repaddress_url="$h_address_url/$number_ver"

ip_addr=$(nvram get wan0_ipaddr)
var_usr=$(nvram get http_username)  		## root
var_pwd=$(nvram get http_passwd)    		## $password
hname=$(nvram get lan_hostname)				## Host name
wkgrp=$(nvram get usb_smbwrkgrp_x)  
routerid=$(nvram get productid)				## наименование модели роутера "RT-N16"
kernel=$(uname -r)
veros=$(expr substr $kernel 1 3)
ver_firmware=$(cat /.version)
#var_ftp_port=$(nvram get usb_ftpport_x)
#var_ssh_port=$(nvram get ssh_port)

iplan_pr=`ip -o -f inet addr show br0 | awk '{print $4;}'`				## 192.168.1.1/24
network=`ip route list dev br0 scope link | awk '{print $1}'`  		## 192.168.1.0/24
iplan_ad=`ip route list dev br0 proto kernel scope link | awk '{print $1};' | cut -d/ -f 1` ## 192.168.1.0
rootname=`cat /etc/group | grep root | awk -F : '{print $4}'`  		## root
iplanaddr=$(nvram get lan_ipaddr) 												## 192.168.1.1
masklan=$(nvram get lan_netmask) 												## 255.255.255.0
gmail_u=""																				## логин для входа в Gmail.com
gmail_p=""   																			## пароль на доступ в Gmail.com


a_bell="\007"
a_std="\033[m"

#Foreground colors:
a_gray="\033[1;30m"
a_red="\033[1;31m"
a_green="\033[1;32m"
a_yellow="\033[1;33m"
a_blue="\033[1;34m"
a_magenta="\033[1;35m"
a_cyan="\033[1;36m"
a_white="\033[1;37m"

#ansi2_gray="\033[0;30m"
#ansi2_red="\033[0;31m"
#ansi2_green="\033[0;32m"
#ansi2_brown="\033[0;33m"
#ansi2_blue="\033[0;34m"
#ansi2_magenta="\033[0;35m"
#ansi2_cyan="\033[0;36m"
#ansi2_white="\033[0;37m"
#ansi2_def="\033[0;3m"

# backgrounds colors
#black="\033[40m"
#red="\033[41m"
#green="\033[42m"
#brown="\033[43m"
#blue="\033[44m"
#magenta="\033[45m"
#cyan="\033[46m"
#gray="\033[47m"
#def="\033[49m"

# ----- Выбор языка диалога, по умолчанию "Russian", ожидание 10 сек.
if [ -e /opt/bin/clear ]; then clear; fi
echo; echo
echo -e "          $a_white ═══ Main Language ═══$a_std"
echo -e "           \033[1;34m[\033[1;33m1 R\033[mussian (Русский)\033[1;34m]\033[m"
echo -e "            \033[1;33m2 E\033[mnglish"
echo
echo -e -n "	Select the menu item "; read -t 10 cs_lg
case $cs_lg in
	[1rR]) v_lan="RU"
		INSTAL="Установка"
		PLUGIN="плагина"
		EXIT="Выход"
		;;
	[2eE]) v_lan="ENG"
		INSTAL="Installing"	
		PLUGIN="plugin"
		EXIT="Exit"
		;;
	*) v_lan="RU"
		INSTAL="Установка"
		PLUGIN="плагина"
		EXIT="Выход"
		;;
esac
#	if [ "$v_lan" = "RU" ]; then
#	else
#	fi


dummy=0
est=0

stop_srv()
{
echo
if [ "$v_lan" = "RU" ]; then echo -e "$a_red Остановка служб ...$a_std"; else echo -e "$a_red STOP$a_white all services ...$a_std"; fi

if [ -e /opt/etc/init.d ]; then
	for i in /opt/etc/init.d/S??* ;do
		[ ! -f "$i" ] && continue
		case "$i" in
			*.sh)
				(
				trap - INT QUIT TSTP
				set stop
				. $i
				)
				;;
			*)
				$i stop
				;;
		esac
	done
fi
sleep 10
return
}

umount_disc()
{
echo
if [ "$v_lan" = "RU" ]; then echo -e "$a_white Размонтирование файловой системы ...$a_std"; else echo -e "$a_white Unmounting filesystems ...$a_std"; fi

for devf in `cat /proc/mounts | grep ext3 | awk '{print($2)}'`; do
	fuser -k $devf
	sleep 2
	umount -l $devf
	sleep 2
done
return
}

recovery()
{
echo
if [ "$v_lan" = "RU" ]; then
	echo -e "Проверить $a_white$var_hard HDD$a_std диск(и) на ошибки$a_white (y/n)$a_std ?" >& 2	
else
	echo -e "Check $a_white$var_hard HDD$a_std disk on errors$a_white (y/n)$a_std ?" >& 2
fi

while echo; do 
	read yn rest
	echo
	case $yn in
		[yY])
			stop_srv
			sleep 10
			umount_disc
			
			if [ $veros = 2.6 ] ; then
				if [ $var_hard = "ONE" ] ; then
					echo -e "$a_white Now check on errors the$a_green OPT$a_white partition ...$a_std"
					e2fsck -f -y -v /dev/sda2
					echo -e "$a_white Now check on errors the$a_green DATA$a_white partition ...$a_std"
					e2fsck -f -y -v /dev/sda3
				else
					echo -e "$a_white Now check on errors the$a_green OPT$a_white partition$a_green FIRST HDD$a_white ...$a_std"
					e2fsck -f -y -v /dev/sda2
					echo -e "$a_white Now check on errors the$a_green DATA$a_white partition$a_green FIRST HDD$a_white ...$a_std"
					e2fsck -f -y -v /dev/sda3
					echo -e "$a_white Now check on errors the$a_green DATA$a_white partition$a_green SECOND HDD$a_white ...$a_std"
					e2fsck -f -y -v /dev/sdb1
				fi
			else
				if [ $var_hard = "ONE" ] ; then
					echo -e "$a_white Now check on errors the$a_green OPT$a_white partition ...$a_std"
					e2fsck -f -y -v /dev/discs/disc0/part2
					echo -e "$a_white Now check on errors the$a_green DATA$a_white partition ...$a_std"
					e2fsck -f -y -v /dev/discs/disc0/part3
				else
					echo -e "$a_white Now check on errors the$a_green OPT$a_white partition$a_green FIRST HDD$a_white ...$a_std"
					e2fsck -f -y -v /dev/discs/disc0/part2
					echo -e "$a_white Now check on errors the$a_green DATA$a_white partition$a_green FIRST HDD$a_white ...$a_std"
					e2fsck -f -y -v /dev/discs/disc0/part3
					echo -e "$a_white Now check on errors the$a_green DATA$a_white partition$a_green SECOND HDD$a_white ...$a_std"
					e2fsck -f -y -v /dev/discs/disc1/part1
				fi
			fi
			
			echo
			echo -e "Press$a_white ENTER$a_std for$a_red REBOOT$a_std ..."
			read dummy
			echo ; echo ; echo ; echo ; echo ; echo ; echo ; echo
			echo -e "                      $a_green Wait for$a_red REBOOT$a_green ...$a_std"
			sleep 10
			reboot
			exit 0
			;;
		[nN]) rm -f /tmp/local/root/*.sh
			echo -e "                      $a_green -= Exit install program =-$a_std"
			exit 0
			;;
		*)   echo  -e " Please answer$a_white y$a_std or$a_white n$a_std" >&2
			;;
	esac
done
}

config_ipkg()
{
echo
if [ "$v_lan" = "RU" ]; then echo -e "$a_white Установка IPKG ...$a_std"; else echo -e "$a_white IPKG installation ...$a_std"; fi

rm /etc/ipkg.conf
rm /opt/etc/ipkg.conf
echo "src wl500g-d http://wl500g.googlecode.com/svn/ipkg/optware-d" 									>> /etc/ipkg.conf
if [ "$repository" = "main" ] ; then
	echo "src optware http://ipkg.nslu2-linux.org/feeds/optware/oleg/cross/stable" 				>> /etc/ipkg.conf
	echo "#src optware http://ipkg3.nslu2-linux.org/feeds/optware/oleg/cross/stable" 			>> /etc/ipkg.conf
	echo "#src optware http://ftp.osuosl.org/pub/nslu2/feeds/optware/oleg/cross/stable" 		>> /etc/ipkg.conf
	echo "#src optware http://dl.dropbox.com/u/45883196/feeds/optware/oleg/cross/stable" 		>> /etc/ipkg.conf

	echo "src/gz optware http://ipkg.nslu2-linux.org/feeds/optware/oleg/cross/stable" 			>> /opt/etc/ipkg.conf
	echo "#src/gz optware http://ipkg3.nslu2-linux.org/feeds/optware/oleg/cross/stable" 		>> /opt/etc/ipkg.conf
	echo "#src/gz optware http://ftp.osuosl.org/pub/nslu2/feeds/optware/oleg/cross/stable" 	>> /opt/etc/ipkg.conf
	echo "#src/gz optware http://dl.dropbox.com/u/45883196/feeds/optware/oleg/cross/stable" 	>> /opt/etc/ipkg.conf
elif [ "$repository" = "mirror1" ] ; then
	echo "#src optware http://ipkg.nslu2-linux.org/feeds/optware/oleg/cross/stable" 				>> /etc/ipkg.conf
	echo "src optware http://ipkg3.nslu2-linux.org/feeds/optware/oleg/cross/stable" 				>> /etc/ipkg.conf
	echo "#src optware http://ftp.osuosl.org/pub/nslu2/feeds/optware/oleg/cross/stable" 		>> /etc/ipkg.conf
	echo "#src optware http://dl.dropbox.com/u/45883196/feeds/optware/oleg/cross/stable" 		>> /etc/ipkg.conf

	echo "#src/gz optware http://ipkg.nslu2-linux.org/feeds/optware/oleg/cross/stable" 			>> /opt/etc/ipkg.conf
	echo "src/gz optware http://ipkg3.nslu2-linux.org/feeds/optware/oleg/cross/stable" 			>> /opt/etc/ipkg.conf
	echo "#src/gz optware http://ftp.osuosl.org/pub/nslu2/feeds/optware/oleg/cross/stable" 	>> /opt/etc/ipkg.conf
	echo "#src/gz optware http://dl.dropbox.com/u/45883196/feeds/optware/oleg/cross/stable" 	>> /opt/etc/ipkg.conf
elif [ "$repository" = "mirror2" ] ; then
	echo "#src optware http://ipkg.nslu2-linux.org/feeds/optware/oleg/cross/stable" 				>> /etc/ipkg.conf
	echo "#src optware http://ipkg3.nslu2-linux.org/feeds/optware/oleg/cross/stable" 			>> /etc/ipkg.conf
	echo "src optware http://ftp.osuosl.org/pub/nslu2/feeds/optware/oleg/cross/stable" 			>> /etc/ipkg.conf
	echo "#src optware http://dl.dropbox.com/u/45883196/feeds/optware/oleg/cross/stable" 		>> /etc/ipkg.conf

	echo "#src/gz optware http://ipkg.nslu2-linux.org/feeds/optware/oleg/cross/stable" 			>> /opt/etc/ipkg.conf
	echo "#src/gz optware http://ipkg3.nslu2-linux.org/feeds/optware/oleg/cross/stable" 		>> /opt/etc/ipkg.conf
	echo "src/gz optware http://ftp.osuosl.org/pub/nslu2/feeds/optware/oleg/cross/stable" 		>> /opt/etc/ipkg.conf
	echo "#src/gz optware http://dl.dropbox.com/u/45883196/feeds/optware/oleg/cross/stable" 	>> /opt/etc/ipkg.conf
elif [ "$repository" = "archive" ]; then
	echo "#src optware http://ipkg.nslu2-linux.org/feeds/optware/oleg/cross/stable" 				>> /etc/ipkg.conf
	echo "#src optware http://ipkg3.nslu2-linux.org/feeds/optware/oleg/cross/stable" 			>> /etc/ipkg.conf
	echo "#src optware http://ftp.osuosl.org/pub/nslu2/feeds/optware/oleg/cross/stable" 		>> /etc/ipkg.conf
	echo "src optware http://dl.dropbox.com/u/45883196/feeds/optware/oleg/cross/stable" 		>> /etc/ipkg.conf
	
	echo "#src/gz optware http://ipkg.nslu2-linux.org/feeds/optware/oleg/cross/stable" 			>> /opt/etc/ipkg.conf
	echo "#src/gz optware http://ipkg3.nslu2-linux.org/feeds/optware/oleg/cross/stable" 		>> /opt/etc/ipkg.conf
	echo "#src/gz optware http://ftp.osuosl.org/pub/nslu2/feeds/optware/oleg/cross/stable" 	>> /opt/etc/ipkg.conf
	echo "src/gz optware http://dl.dropbox.com/u/45883196/feeds/optware/oleg/cross/stable" 	>> /opt/etc/ipkg.conf
fi
echo "dest root /" 																									>> /etc/ipkg.conf

echo "src/gz wl500g-d http://wl500g.googlecode.com/svn/ipkg/optware-d" 								>> /opt/etc/ipkg.conf
echo "src/gz wl500g-optware http://wl500g.googlecode.com/svn/ipkg/optware" 						>> /opt/etc/ipkg.conf
echo ""				 																									>> /opt/etc/ipkg.conf
echo "dest /opt/ /" 																									>> /opt/etc/ipkg.conf
echo "option verbose-wget" 																						>> /opt/etc/ipkg.conf

/usr/bin/ipkg.sh -force-defaults update
/usr/bin/ipkg.sh -force-defaults install ipkg-opt

ipkg -force-defaults update
sleep 2
return
}


## menu
v_samb="v.2"
v_cron="crond"
v_inte="NO"	#internet_access
v_hard="ONE"

mt_tor="BitTorrent (Transmission or rTorrent)   "
mt_cms="CMS (Sawanna or phpSQLiteCMS)           "
mt_upn="UPnP MediaServer                        "
mt_sms="SMS service (Mail.Ru Agent)             "
mt_rrd="RRDTool Traffic Graph Page              "

mv_upn=" "	#upnp Media
mv_cms=" "	#WEB cms
mv_vns=" "	#
mv_img=" "	#image
mv_icq=" "	#icq
mv_sms=" "	#sms
mv_frm=" "	#forum
mv_mld=" "
mv_sql=" "	#mysql
mv_dbh=" "
mv_mdc=" "
mv_vpn=" "	#vpn
mv_bcp=" "
mv_pld=" "	
mv_rrd=" "	#rrd
mv_nod=" "	#nod32
mv_pvx=" "	
mv_sts=" "	#status
mv_tor=" "  #torrent
mv_ado=" "  #ados
mv_ntp=" "  #NTP Server

dobavka="═══"


## Производилась ли ранее установка данным скриптом?
if [ -e "/opt/share/www/.ver" ]; then
	# Скрипт использовался ранее
	format="UPDATE" 
	color_format=$a_green
	t_disk="yes"
else
	# Скрипт запускается впервые
	format="FORMAT"
	color_format=$a_red
	dobavka="═══"
	t_disk="no"
fi

repository="main"
phone="           "
pages="FIRST"
dobavka2="═"

color_ver="\033[44;44;44;1m"
color_repository=$a_green
c_i_a=$a_red
repository_url="http://ipkg.nslu2-linux.org"

# добавление пунктов меню из дополнительных (Дочерних) скриптов   --- В РАЗРАБОТКЕ ---
#m_sel=0
#echo "" > menu.d
#for file in *.shm
#do
#  let m_sel=$m_sel+1
#  echo "$m_sel $file `cat $file|grep MENUTXT|sed s/[[:alnum:]]*=//g`" >> menu.d		#прочитать из дополнительных скриптов наименование предлагаемой программы
#done

#############################################################################################
##                                  Start Main program                                     ##
#############################################################################################
while [ $est -eq 0 ] ; do
	if [ -e /opt/bin/clear ]; then clear; fi

	if [ "$format" = "UPDATE" ] ; then				
		ud_mn="\033[m"										## в случае выбора UPDATE деактивировать меню (панель справа)
		up_wk=$(nvram get usb_smbwrkgrp_x)        ## запросить текущие установки
		up_hn=$(nvram get lan_hostname)				## и вывести их на экран

		if [ -e "/opt/etc/init.d/S10crond" ]; then up_cr="crond"
		elif [ -e "/opt/etc/init.d/S10cron" ]; then up_cr="cron"
		fi
		
		if [ -e "/opt/etc/init.d/S97Samba" ]; then up_sa="v.2"
		elif [ -e "/opt/etc/init.d/S08samba" ]; then up_sa="v.3.5$a_std + Admin. Web"
		fi
		
		## проверка открытого 80 порта 
		#iptables-save -t filter | fgrep -e '-A INPUT -p tcp -m tcp --dport 80 -j ACCEPT'
		#if [ "$?" -eq "0"] ; then
		#	echo "Internet Access On"
		#	v_inte="YES"
		#else
		#	echo "Internet Access Off"
		#	v_inte="NO"
		#fi

#		v_hard="ONE"
	else
		ud_mn="\033[1;33m"
		up_wk=$wkgrp
		up_hn=$hname
		up_cr=$v_cron
		up_sa=$v_samb
	fi

	echo ; echo ; echo ; echo ; echo
	if [ "$v_lan" = "RU" ]; then
		if [ "$format" = "UPDATE" ] ; then #Скрыть пункты меню если выделен режим UPDATE
			#ud_mn="\033[30;40m"
			mu_W=""
			mu_N=""
			mn_0=""
			mu_I="\033[1;33m I\033[m"
			mu_H=""
			mu_J=""
			mu_S=""
		else
			mu_W="$ud_mn W\033[m"
			mu_N="$ud_mn N\033[m"
			mn_0="  "
			mu_I="$ud_mn I\033[m"
			mu_H="$ud_mn H\033[m"
			mu_J="$ud_mn J\033[m"
			mu_S="$ud_mn S\033[m"
		fi
		line01="│ Роутер: $a_white$routerid$a_std"
		line02="│ Прошивка: $a_white$ver_firmware$a_std"
		line03="│ Версия ОС Linux: $a_white$kernel$a_std"
		line04="├──────────────────────────────"
		line05="│$mu_W Рабочая группа: $a_green$up_wk$a_std"
		line06="│$mu_N Имя: $a_green$up_hn$a_std"
		line07="│$mn_0 IP-адрес: $a_green$iplan_pr$a_std"
		line08="├──────────────────────────────"
		line09="│$mu_I Доступ снаружи: $c_i_a$v_inte$a_std"
		line10="│$mu_H Кол-во дисков: $a_green$v_hard$a_std"
		line11="│$mu_J Планировщик заданий: $a_green$up_cr$a_std"
		line12="│$mu_S Samba \033[1;32m$up_sa$a_std"
		line13="│"

		echo -e "$a_magenta (\___/)$a_green Установка программ на роутеры $a_white ASUS\033[1;32m,$a_white D-Link\033[1;32m,$a_white NetGear\033[1;32m          $color_ver$number_ver$a_std"
		echo -e "$a_magenta (='.'=)$a_green с альтернативными прошивками: $a_white 1.9.2.7-d-rXXXX$a_green или$a_white 1.9.2.7-rtn-rXXXX$a_std "
		echo -e "$a_magenta (\")_(\")$a_green для версии ОС Linux:$a_white 2.4.X.X$a_green и $a_white 2.6.X.X$a_std         IP: $a_white$ip_addr$a_std"
		echo -e " ═══════════$a_white Статус установки: $color_format$format$a_std $dobavka══════╤══════════════════════════════"
	else
		line01="│ Your router: $a_white$routerid$a_std"
		line02="│ Firmware: $a_white$ver_firmware$a_std"
		line03="│ Linux version: $a_white$kernel$a_std"
		line04="├──────────────────────────────"
		line05="│$ud_mn W\033[morkgroup Name: $a_green$up_wk$a_std"
		line06="│ Host$ud_mn N\033[mame: $a_green$up_hn$a_std"
		line07="│ IP LAN: $a_green$iplan_pr$a_std"
		line08="├──────────────────────────────"
		line09="│$ud_mn I\033[mnternet access: $c_i_a$v_inte$a_std"
		line10="│$ud_mn H\033[mDD connected: $a_green$v_hard$a_std"
		line11="│$ud_mn J\033[mob scheduler: $a_green$up_cr$a_std"
		line12="│$ud_mn S\033[mamba \033[1;32m$up_sa$a_std"
		line13="│"

		echo -e "$a_magenta (\___/)$a_green Install program for routers$a_white ASUS$a_green or$a_white D-Link$a_green or$a_white NetGear          $color_ver$number_ver$a_std"
		echo -e "$a_magenta (='.'=)$a_green with firmware:$a_white 1.9.2.7-d-rXXXX$a_green or$a_white 1.9.2.7-rtn-rXXXX$a_std "
		echo -e "$a_magenta (\")_(\")$a_green for versions OS Linux:$a_white 2.4.X.X$a_green or$a_white 2.6.X.X$a_std         IP: $a_white$ip_addr$a_std"
		echo -e " ═════════════$a_white Install status: $color_format$format$a_std $dobavka══════╤══════════════════════════════"
	fi
	if [ "$pages" = "FIRST" ] ; then
		echo -e "$a_yellow a$a_std $mt_tor [$a_cyan$mv_tor$a_std]$line01"
		echo -e "$a_yellow b$a_std $mt_cms [$a_cyan$mv_cms$a_std]$line02"
		echo -e "$a_yellow c$a_std $mt_upn [$a_cyan$mv_upn$a_std]$line03"
		echo -e "$a_yellow d$a_std Polipo & Privoxy (proxy and filters)     [$a_cyan$mv_pvx$a_std]$line04"
		echo -e "$a_yellow e$a_std Site Status Router                       [$a_cyan$mv_sts$a_std]$line05"
		echo -e "$a_yellow f$a_std Imagevue v.2 (Flash Photo Gallery)       [$a_cyan$mv_img$a_std]$line06"
		echo -e "$a_yellow g$a_std $mt_rrd [$a_cyan$mv_rrd$a_std]$line07"                                               
		echo -e "$a_yellow h$a_std vnStat v.1.5.1                           [$a_cyan$mv_vns$a_std]$line08"
		echo -e "$a_yellow i$a_std Nod32update server(VER=0.6.11b) fo v.3|4 [$a_cyan$mv_nod$a_std]$line09"
		echo -e "$a_yellow j$a_std Forum (ExBB FM 1.0 RC1)                  [$a_cyan$mv_frm$a_std]$line10"
		echo -e "$a_yellow k$a_std Backup for E-Mail(gmail.com)             [$a_cyan$mv_bcp$a_std]$line11"
		echo -e "$a_yellow l$a_std $mt_sms [$a_cyan$mv_sms$a_std]$line12"
		echo -e "$a_yellow m$a_std ADOS (Automatic DOwnload System)         [$a_cyan$mv_ado$a_std]$line13"
	elif [ "$pages" = "SECOND" ] ; then
		echo -e "$a_yellow n$a_std Web2ICQ v.1.0                            [$a_cyan$mv_icq$a_std]$line01"
		echo -e "$a_yellow o$a_std OpenVPN (Server)                         [$a_cyan$mv_vpn$a_std]$line02"
		echo -e "$a_yellow p$a_std MLDonkey (Donkey, BitTorrent, FileTP)    [$a_cyan$mv_mld$a_std]$line03"
		echo -e "$a_yellow q$a_std microdc2 (client DC++)                   [$a_cyan$mv_mdc$a_std]$line04"
		echo -e "$a_yellow r$a_std MySQL & phpMyAdmin                       [$a_cyan$mv_sql$a_std]$line05"
		echo -e "$a_yellow s$a_std DBHub & RRDtool Stats & Scripts (Perl)   [$a_cyan$mv_dbh$a_std]$line06"
		echo -e "$a_yellow t$a_std NTP Server (ntpd)                        [$a_cyan$mv_ntp$a_std]$line07"
		echo -e "$a_yellow u$a_std                                             $line08"
		echo -e "$a_yellow v$a_std                                             $line09"
		echo -e "$a_yellow w$a_std                                             $line10"
		echo -e "$a_yellow x$a_std                                             $line11"
		echo -e "$a_yellow y$a_std                                             $line12"
		echo -e "$a_yellow z$a_std                                             $line13"
	elif [ "$pages" = "THIRD" ] ; then
		echo -e "                                               $line01"
		echo -e "                                               $line02"
		echo -e "                                               $line03"
		echo -e "                                               $line04"
		echo -e "                                               $line05"
		echo -e "                                               $line06"
		echo -e "                                               $line07"
		echo -e "                                               $line08"
		echo -e "                                               $line09"
		echo -e "                                               $line10"
		echo -e "                                               $line11"
		echo -e "                                               $line12"
		echo -e "                                               $line13"
	fi
	echo " ──────────────────────────────────────────────┴──────────────────────────────"
	if [ "$t_disk" = "yes" ]; then echo -e -n "$a_green +$a_std "; else echo -e -n "   "; fi  # Отображать пункт меню "+"
	if [ "$v_lan" = "RU" ]; then
		echo -e "Выбран режим установки $color_format$format$a_std (FORMAT, UPDATE или REINSTALL)"
		echo -e "$a_green =$a_std Выбран $color_repository$repository$a_std репозиторий - $color_repository$repository_url$a_std"
		echo -e "$a_red !$a_white Запуск установки программ в режиме $color_format$format$a_std c $a_white$v_hard HDD$a_std или $a_yellow 0$a_std для Выхода"
		echo -e "$a_red ^$a_std Проверить $a_white$v_hard HDD$a_std диск(и) на ошибки"
		echo -e " ═════════════════════════════════════════════════════════════$dobavka2$a_yellow P\033[mage$a_white $pages$a_std ═══"
		echo -n " Введите пункт меню: "  
	else
		echo -e "Choice Install $color_format$format$a_std (FORMAT, UPDATE or REINSTALL)"
		echo -e "$a_green =$a_std Choice $color_repository$repository$a_std repository - $color_repository$repository_url$a_std"
		echo -e "$a_red !$a_white Start Install program with $color_format$format$a_std on $a_white$v_hard HDD$a_std or$a_yellow 0$a_std for Exit"
		echo -e "$a_red ^$a_std Check $a_white$v_hard HDD$a_std disk(s) on errors"
		echo -e " ═════════════════════════════════════════════════════════════$dobavka2$a_yellow P\033[mage$a_white $pages$a_std ═══"
		echo -n " Enter your menu choice: "  
	fi
	read choice
	
	case $choice in ##  блокировать невидимые пункты
		[a-m]) if [ "$pages" != "FIRST" ]; then choice=""; fi;;
		[n-x]) if [ "$pages" != "SECOND" ]; then choice=""; fi;;
		[WNHJS]) if [ "$format" = "UPDATE" ]; then choice=""; fi;;  ## Блокировать в режиме UPDATE
		+) if [ "$t_disk" = "no" ]; then choice=""; fi #блокировать если диск не форматировался
	esac

	case $choice in
		a)	echo
			echo -e " $a_white ═══ Bittorent Client: ═══ $a_std"
			echo -e " $a_yellow  1\033[m Transmission"
			echo -e " $a_yellow  2\033[m rTorrent + ruTorrent v3.3"
			echo -e " \033[1;34m[\033[1;33m$a_yellow 0\033[m - $EXIT - \033[1;34m]\033[m"
			echo
			if [ "$v_lan" = "RU" ]; then echo -e -n " Введите пункт меню: "; else echo -e -n "Select the menu number: "; fi  
			read -n1 -t 30 cs_tr
			case $cs_tr in
				1) mv_tor="x"; mt_tor="\033[1;37mTransmission 1.93-1\033[m (BitTorrent Client) ";;
				2) mv_tor="x"; mt_tor="\033[1;37mrTorrent + ruTorrent v3.3\033[m(BitTorrent C.)" ;;
				*) mv_tor=" "; mt_tor="BitTorrent (Transmission or rTorrent)   ";;
			esac;; 
		b)	echo
			echo -e " $a_white ═══ Content Management System: ═══$a_std"
			echo -e " $a_yellow  1\033[m Sawanna ver.2.8.5"
			echo -e " $a_yellow  2\033[m phpSQLite"
			echo -e " \033[1;34m[\033[1;33m$a_yellow 0\033[m - $EXIT - \033[1;34m]\033[m"
			echo
			if [ "$v_lan" = "RU" ]; then echo -e -n " Введите пункт меню: "; else echo -e -n "Select the menu number: "; fi  
			read -n1 -t 30 cs_cm
			case $cs_cm in
				1) mv_cms="x"; mt_cms="\033[1;37mSawanna ver.2.8.5\033[m (CMS)                 ";;
				2) mv_cms="x"; mt_cms="\033[1;37mphpSQLiteCMS\033[m (CMS)                      ";;
				*) mv_cms=" "; mt_cms="CMS (Sawanna or phpSQLite)              ";;
			esac;;
		c) echo
			echo -e " $a_white ═══ UPnP MediaServer: ═══$a_std"
			echo -e " $a_yellow  1\033[m TwonkyMedia v.6.0.30"
			echo -e " $a_yellow  2\033[m MediaTomb"
			echo -e " $a_yellow  3\033[m Ushare"
			echo -e " \033[1;34m[\033[1;33m$a_yellow 0\033[m - $EXIT - \033[1;34m]\033[m"
			echo
			if [ "$v_lan" = "RU" ]; then echo -e -n " Введите пункт меню: "; else echo -e -n "Select the menu number: "; fi  
			read -n1 -t 30 cs_up
			case $cs_up in
				1) mv_upn="x"; mt_upn="\033[1;37mTwonkyMedia v.6.0.30\033[m (UPnP MediaServer) ";;
				2) mv_upn="x"; mt_upn="\033[1;37mMediaTomb\033[m (UPnP MediaServer)            ";;
				3) mv_upn="x"; mt_upn="\033[1;37mUshare\033[m (UPnP MediaServer)               ";;
				*) mv_upn=" "; mt_upn="UPnP MediaServer                        ";;
			esac;;
		d) if [ "$mv_pvx" = " " ]; then mv_pvx="x"; else mv_pvx=" "; fi;;			# Polipo & Privoxy (proxy and filters)
		e) if [ "$mv_sts" = " " ]; then mv_sts="x"; else mv_sts=" "; fi;;			# Site Status Router  
		f) if [ "$mv_img" = " " ]; then mv_img="x"; else mv_img=" "; fi;;			# Imagevue v.2 (Flash Photo Gallery) 
		g) echo
			echo -e " $a_white ═══ RRDTool Traffic Graph Page ═══ $a_std"
			echo -e " $a_yellow  1\033[m rrd"
			echo -e " $a_yellow  2\033[m rrd_new (script v.12)"
			echo -e " \033[1;34m[\033[1;33m$a_yellow 0\033[m - $EXIT - \033[1;34m]\033[m"
			echo
			if [ "$v_lan" = "RU" ]; then echo -e -n " Введите пункт меню: "; else echo -e -n "Select the menu number: "; fi  
			read -n1 -t 30 cs_rr
			case $cs_rr in
				1) mv_rrd="x"; mt_rrd="RRDTool Traffic Graph Page (\033[1;37mrrd\033[m)        ";;
				2) mv_rrd="x"; mt_rrd="RRDTool Traffic Graph Page (\033[1;37mrrd_new\033[m)    ";;
				*) mv_rrd=" "; mt_rrd="RRDTool Traffic Graph Page              ";;
			esac;;
		h) if [ "$mv_vns" = " " ]; then mv_vns="x"; else mv_vns=" "; fi;;			# vnStat v.1.5.1 
		i) if [ "$mv_nod" = " " ]; then mv_nod="x"; else mv_nod=" "; fi;;			# NOD32
		j) if [ "$mv_frm" = " " ]; then mv_frm="x"; else mv_frm=" "; fi;;			# Forum
		k) if [ "$mv_bcp" = " " ] ; then  													# Backup for Email
				mv_bcp="x"
				
				## ввод логина
				txtmail=""
				if [ ! -z "$gmail_u" ] ; then 
					txtmail=" [$gmail_u]"
				fi
				if [ "$v_lan" = "RU" ]; then
					echo -e -n "Введите Имя учетной записи Google$txtmail: "
				else
					echo -e -n "Google Account Username$txtmail: "
				fi
				read gmail_uw
				if [ -z "$gmail_uw" ] && [ ! -z "$gmail_u" ] ; then
					gmail_uw=$gmail_u
				elif [ -z "$gmail_uw" ]; then
					echo "Ошибка ввода!"
					sleep 2
				else
					gmail_u=$gmail_uw
				fi
				
				## ввод пароля
				txtmail=""
				if [ ! -z "$gmail_p" ] ; then txtmail=" [$gmail_p]"; fi

				if [ "$v_lan" = "RU" ]; then
					echo -e -n "Введите пароль учетной записи Google$txtmail: "
				else
					echo -e -n "Google Account Password$txtmail: "
				fi
				
				read gmail_pw
				if [ -z "$gmail_pw" ] && [! -z "$gmail_p"] ; then
					gmail_pw=$gmail_p
				else
					gmail_p=$gmail_pw
				fi
				
				if [ -z "$gmail_uw" ] ; then
					mv_bcp=" no"
				fi
			else
				mv_bcp=" "
			fi
			;;
		l) if [ "$mv_sms" = " " ]; then  #SMS
				m_c=1
				mv_sms="x"
				echo
				if [ "$v_lan" = "RU" ]; then
					echo -e "    Программа \"\033[1;37mSMS service (Mail.Ru Agent)\033[m\" предназначена для доставки бесплатных SMS сообщений  о состоянии работы роутера и текстовых сообщений через web-интерфейс (\033[1;34mhttp://my.router/sms\033[m) на мобильные телефоны следующих операторов: Россия (МТС, Билайн, Мегафон, ТЕЛЕ2, НТК, НСС, Смартс, Мотив, ЕТК, Utel, SkyLink), Казахстан (Kcell, Билайн, NEO), Узбекистан (МТС, Билайн, Ucell, PerfectumMobile), Украина (life, МТС, IT), Таджикистан (Tcell, Билайн), Кыргызстан (MegaCom)"			
					echo " -------------------------------------------------------------------------"
					echo -e "    Для получения системных уведомлений (загрузка роутера, отсутствие связи с хостом, завершение закачки Торрента) на сотовый телефон, необходимо ввести номер получателя в формате$a_white 79161234567$a_std. В случае отказа, системные сообщения доставляться не будут"
				else
					echo -e "   The program \"\033[1;37mSMS service (Mail.Ru Agent)\033[m\" is designed to deliver free SMS messages on the status of the router and text messages via a web-interface (\033[1;34mhttp://my.router/sms \033[m) to mobile phones operators: Russia (MTS, Beeline, Megafon, Tele2, STC, HCC, Smarts, Motive, UCC, Utel, SkyLink), Kazakhstan (Kcell, Beeline, NEO), Uzbekistan (MTS, Beeline, Ucell, PerfectumMobile), Ukraine (life, MTS, IT), Tajikistan (Tcell, Beeline), Kyrgyzstan (MegaCom)"			
					echo " -------------------------------------------------------------------------"
					echo -e -n "   To receive notification of system (loading the router, no connection to the host, the injection torrent) on a cell phone, you must enter the recipient's number in the format $a_white 79161234567\033[m. In case of failure, system messages will not be delivered"
				fi
				read -p ">" phone
				echo
				if [ ! -z "$phone" ]; then
					mt_sms="SMS service (Mail.Ru Agent) $a_cyan$phone$a_std "
					echo " -------------------------------------------------------------------------"
					if [ "$v_lan" = "RU" ]; then 
						echo -e -n " Для контроля наличия/отсутствия связи, введите наименование контролируемого хоста или IP-адреса (ya.ru, 192.168.1.2) [\033[1;37mNo\033[m]"
					else
						echo -e -n " To control the presence/absence of connection, type the name of the monitored host or IP-address (ya.ru, 192.168.1.2) [\033[1;37mNo\033[m]"
					fi
					read -p ">" sms_ping; if [ -z "$sms_ping" ] ; then sms_ping="no"; fi
					echo
				else
					mt_sms="SMS service (Mail.Ru Agent)             "
				fi

				echo " -------------------------------------------------------------------------"
				if [ "$v_lan" = "RU" ]; then 
					echo -e " Настройка \"SMS service (Mail.Ru Agent)\".    Для работы программы необходимо ввести несколько аккаунтов электронной почты (http://mail.ru)"
				else
					echo -e " Setting \"SMS service (Mail.Ru Agent) \".   For the program to enter multiple email accounts (http://mail.ru)"
				fi
				while true; do
					echo
					if [ "$v_lan" = "RU" ]; then echo -e -n "Введите почтовый адрес"; else echo -e -n "Enter your email address"; fi
					echo -e -n " ($m_c):";  read mmail_u
					if [ "$v_lan" = "RU" ]; then echo -e -n "Введите пароль"; else echo -e -n "Enter your password"; fi
					echo -e -n " ($m_c):";  read mmail_p
					echo
						
					if [ ! $mmail_u ]; then
						echo -e "$a_red ERROR! when entering the email address! $a_std"
						read dj
						continue
					elif [ ! $mmail_p ]; then
						echo -e "$a_red ERROR! must enter the password$a_std"
						read dj
						continue
					else
						if [ $m_c = 1 ]; then
							mail_smspy="\"$mmail_u\""
							pass_smspy="\"$mmail_p\""
							echo -e "#!/opt/bin/php\r" > send.php
							echo -e "<?php\r" >> send.php
						else
							mail_smspy="\"$mmail_u\", $mail_smspy"
							pass_smspy="\"$mmail_p\", $pass_smspy"
						fi

						let mmc=$m_c-1
						mail_sendsms="\$login[$mmc]=\"$mmail_u\";\r"
						pass_sendsms="\$pass[$mmc]=\"$mmail_p\";\r"
						echo -e "$mail_sendsms" >> send.php
						echo -e "$pass_sendsms" >> send.php

						let "m_c += 1"
					fi

					if [ "$v_lan" = "RU" ]; then echo -e -n "Будем вводить дополнительные почтовые адреса (y/n)? "; else echo -e -n "We will introduce additional accounts (y/n)? "; fi  
					read -n1 yn rest
					case $yn in
						[yY])
							echo
							continue
							;;
						[nN])
							break
							;;
						*)   echo  -e " Please answer$a_white y$a_std or$a_white n$a_std" >&2
							;;
					esac
				done
			else
				mv_sms=" "
				mt_sms="SMS service (Mail.Ru Agent)             "
			fi;;
		m) if [ "$mv_ado" = " " ]; then mv_ado="x"; else mv_ado=" "; fi;;
		n) if [ "$mv_icq" = " " ]; then mv_icq="x"; else mv_icq=" "; fi;;			# Web2ICQ v.1.0 
		o) if [ "$mv_vpn" = " " ]; then														# OpenVPN (Server)
: << COMMENT
				#Keygen ssl 
				#echo -n -e "Генерируем закрытый ключ "
				while true; do

					echo -e -n " Генерировать закрытый ключ (y/n)? "  
					read -n1 yn rest
					case $yn in
						[yY])

#							continue
							;;
						[nN])
							break
							;;
						*)   echo  -e " Please answer$a_white y$a_std or$a_white n$a_std" >&2
							;;
					esac
				done

COMMENT
				
				# Enable the DDNS Client?
				if [ $(nvram get ddns_enable_x) = 1 ]; then 
					adr_openvnp=$(nvram get ddns_hostname_x)
				else
					adr_openvnp=$ip_addr
				fi

				if [ "$v_lan" = "RU" ]; then
					echo -n -e "Введите адрес сервера OpenVPN [$a_white$adr_openvnp$a_std]: "
				else
					echo -n -e "Enter the address of the OpenVPN server [$a_white$adr_openvnp$a_std]: "
				fi
				read; if [ -n "$REPLY" ]; then adr_openvnp=$REPLY; fi
				
				port_openvpn=1194
				if [ "$v_lan" = "RU" ]; then
					echo -n -e " Введите порт OpenVPN сервера [$a_white$port_openvpn$a_std]: "
				else
					echo -n -e " Enter the port OpenVPN server [$a_white$port_openvpn$a_std]: "
				fi
				read port_openvpn; if [ -z "$port_openvpn" ]; then port_openvpn=1194; fi

#				echo -e "Укажите типа используемого интерфейса и режима работы: [tun] = L3-туннель, [tap] = L2-туннель: "
#				read dev_openvpn
				
				mv_vpn="x"
			else
				mv_vpn=" "
			fi
			;;
		p) if [ "$mv_mld" = " " ]; then mv_mld="x"; else mv_mld=" "; fi;;			# MLDonkey (Donkey, BitTorrent, FileTP) 
		q) if [ "$mv_mdc" = " " ]; then mv_mdc="x"; else mv_mdc=" "; fi;;			# microdc2 (client DC++)   
		r) if [ "$mv_sql" = " " ]; then mv_sql="x"; else mv_sql=" "; fi;;			# MySQL & phpMyAdmin 
		s)	if [ "$mv_dbh" = " " ]; then mv_dbh="x"; else mv_dbh=" "; fi;;			# DBHub & RRDtool Stats & Scripts (Perl)
		t) if [ "$mv_ntp" = " " ]; then mv_ntp="x"; else mv_ntp=" "; fi;;			# NTP Server
#		v)	echo ;;
#		w) echo ;;
#		x) echo ;;
#		y) echo ;;
#		z) echo ;;
		W) if [ "$v_lan" = "RU" ]; then echo -n "Введите имя рабочей группы "; else echo -n "Enter Workgroup Name "; fi
			echo -n "[$(nvram get usb_smbwrkgrp_x)]:" 
			read wkgrp; if [ -z "$wkgrp" ]; then wkgrp=$(nvram get usb_smbwrkgrp_x); fi
			;;
		N) if [ "$v_lan" = "RU" ]; then echo -n "Введите имя хоста "; else echo -n "Enter Host Name "; fi
			echo -n "[$(nvram get lan_hostname)]: "
			read hname; if [ -z "$hname" ]; then hname=$(nvram get lan_hostname); fi
			;;
		H) if [ "$v_hard" = "ONE" ]; then v_hard="TWO"; else v_hard="ONE"; fi;;
		I) if [ "$v_inte" = "YES" ]; then v_inte="NO"; c_i_a=$a_red; else v_inte="YES"; c_i_a=$a_green; fi;;
		S)	if [ "$v_samb" = "v.2" ]; then v_samb="v.3.5$a_std + Admin. Web"; else v_samb="v.2"; fi;;
		P) if [ "$pages" = "FIRST" ]; then
				pages="SECOND"
				dobavka2=""
			elif [ "$pages" = "SECOND" ] ; then
#				pages="THIRD"
#				dobavka2="═"
#			else
				pages="FIRST"
				dobavka2="═"
			fi
			;;
		J) if [ "$v_cron" = "crond" ]; then v_cron="cron"; else v_cron="crond"; fi;;
		+) if [ "$format" = "FORMAT" ] ; then
				format="UPDATE"
				color_format=$a_green
				dobavka="═══"
			elif [ "$format" = "UPDATE" ] ; then
				format="REINSTALL"
				dobavka=""
				color_format=$a_magenta
			elif [ "$format" = "REINSTALL" ] ; then
				format="FORMAT"
				color_format=$a_red
				dobavka="═══"
			fi
			;;
		^) recovery;;
		=) if [ "$repository" = "main" ] ; then
				repository="mirror1"
				color_repository=$a_yellow
				color_repository_url=$a_yellow
				repository_url="http://ipkg3.nslu2-linux.org"
			elif [ "$repository" = "mirror1" ] ; then
				repository="mirror2"
				color_repository=$a_yellow
				color_repository_url=$a_yellow
				repository_url="http://ftp.osuosl.org"
			elif [ "$repository" = "mirror2" ] ; then
				repository="archive"
				color_repository=$a_magenta
				color_repository_url=$a_magenta
				repository_url="http://dl.dropbox.com/.../optware"
			elif [ "$repository" = "archive" ] ; then
				repository="main"
				color_repository=$a_green
				color_repository_url=$a_green
				repository_url="http://ipkg.nslu2-linux.org"
			fi
			;;
		!) let est=$est+1;;
		0) rm -f /tmp/local/root/*.sh; exit 0;;
		*) echo
			echo -e "$a_bell"
			if [ "$v_lan" = "RU" ]; then
				echo -e "$a_red Ошибка$a_std, выберете$a_yellow a - z$a_std ,$a_green +$a_std ,$a_green =$a_std ,$a_red !$a_std ,$a_red ^$a_std or $a_white 0$a_std - for exit:";
				echo
				echo -n -e "Нажмите$a_green ENTER$a_std для возврата в главное меню ..."
			else
				echo -e "$a_red Error$a_std, select$a_yellow a - z$a_std ,$a_green +$a_std ,$a_green =$a_std ,$a_red !$a_std ,$a_red ^$a_std or $a_white 0$a_std - for exit:";
				echo
				echo -n -e "Press$a_green ENTER$a_std to return to main menu ..."
			fi
			read dummy
			;;
	esac
done

#диалог подтверждения начала установки программ
echo
if [ "$v_lan" = "RU" ]; then
	txt="$*$a_white Начать установку программ в режиме $color_format $format$a_std с $a_white$v_hard HDD$a_std ...$a_white (y/n)$a_std ?"
else
	txt="$*$a_white Start Install program with$color_format $format$a_std on $a_white$v_hard HDD$a_std ...$a_white (y/n)$a_std ?"
fi
while echo -e $txt >& 2
do   read yn rest
	echo
	case $yn in
		[yY]) break;;
		[nN]) rm -f /tmp/local/root/*.sh
			echo ; echo ; echo
			if [ "$v_lan" = "RU" ]; then
				echo -e "                      $a_green -= Выход из программы установки =-$a_std"
			else 
				echo -e "                          $a_green -= Exit install program =-$a_std"
			fi
			exit 0
			;;
		*) if [ "$v_lan" = "RU" ]; then
				echo  -e " Введите, пожалуйста,$a_white y$a_std или$a_white n$a_std" >&2
			else
				echo  -e " Please answer$a_white y$a_std or$a_white n$a_std" >&2
			fi
			;;
	esac
done

# Записать в nvram данные если они менялись в меню
if [ "$wkgrp" != $(nvram get usb_smbwrkgrp_x) ]; then nvram set usb_smbwrkgrp_x=$wkgrp; fi
if [ "$hname" != $(nvram get lan_hostname) ]; then nvram set lan_hostname=$hname; fi
nvram commit


#############################################################################################
##                             FORMAT & REINSTALL                                          ##
#############################################################################################

if [ "$format" = "FORMAT" ] || [ "$format" = "REINSTALL" ]; then

	echo
	if [ "$v_lan" = "RU" ]; then echo -e "$a_white Отключение Flashfs ...$a_std"; else echo -e "$a_white Flashfs disable ...$a_std"; fi
	flashfs disable
	
	stop_srv     #Stop all services

	sleep 15
	
	umount_disc   #Umount all disc

	echo
	if [ "$v_lan" = "RU" ]; then
		echo -e "$a_white Создание каталога /tmp/local/sbin и исполняемых скриптов ...$a_std"
	else
		echo -e "$a_white Directory /tmp/local/sbin and startup files created ...$a_std"
	fi
	mkdir -p /tmp/local/sbin
	sleep 3
	
	echo
	if [ "$v_lan" = "RU" ]; then echo -e "$a_white Создание post-boot$a_std"; else echo -e "$a_white Writing post-boot$a_std"; fi
	echo -e "#!/bin/sh" 											>> /tmp/local/sbin/post-boot
	echo -e "chmod 777 /tmp" 									>> /tmp/local/sbin/post-boot
	echo -e "" 														>> /tmp/local/sbin/post-boot	
	echo -e "## Samba File Shares (Web) - Disabled" 	>> /tmp/local/sbin/post-boot
	echo -e "nvram set usb_smbenable_x=0"					>> /tmp/local/sbin/post-boot
	echo -e "nvram set usb_smbcset_x=utf8"					>> /tmp/local/sbin/post-boot
	echo -e ""														>> /tmp/local/sbin/post-boot
	echo -e "## telnet - Off"									>> /tmp/local/sbin/post-boot
	echo -e "#nvram set telnet_enable=0"					>> /tmp/local/sbin/post-boot
	echo -e "nvram commit"										>> /tmp/local/sbin/post-boot
	echo -e ""														>> /tmp/local/sbin/post-boot
	echo -e "# turn off wlan by default"					>> /tmp/local/sbin/post-boot
	echo -e "#sleep 10"											>> /tmp/local/sbin/post-boot
	echo -e "#/usr/sbin/wl radio off"						>> /tmp/local/sbin/post-boot
	echo -e ""														>> /tmp/local/sbin/post-boot

	echo
	if [ "$v_lan" = "RU" ]; then echo -e -n "$a_white Создание "; else echo -e -n "$a_white Writing "; fi; echo -e "pre-boot$a_std"
	echo -e "#!/bin/sh" 																>> /tmp/local/sbin/pre-boot
	echo -e "" 																			>> /tmp/local/sbin/pre-boot
	echo -e "#Both these lines are required/recommended for protection against unwanted multiple ssh" >> /tmp/local/sbin/pre-boot
	echo -e "#logins based on ipt_recent ( http://wl500g.info/showpost.php?p=69660&postcount=53 )" >> /tmp/local/sbin/pre-boot
	echo -e "#date 010101012000" 													>> /tmp/local/sbin/pre-boot
	echo -e "#insmod /usr/local/lib/ipt_recent.o" 							>> /tmp/local/sbin/pre-boot
	echo -e "" 																			>> /tmp/local/sbin/pre-boot
	echo -e "insmod ipt_recent.o" 												>> /tmp/local/sbin/pre-boot
	echo -e "" 																			>> /tmp/local/sbin/pre-boot
	
	echo
	if [ "$v_lan" = "RU" ]; then echo -e -n "$a_white Создание "; else echo -e -n "$a_white Writing "; fi; echo -e "pre-mount$a_std"
	echo -e "#!/bin/sh" 																>> /tmp/local/sbin/pre-mount
	echo -e "" 																			>> /tmp/local/sbin/pre-mount
	if [ "$v_hard" = "TWO" ] ; then
		if [ "$veros" = "2.6" ] ; then
			echo -e "ln -s /tmp/mnt/discb_1 /tmp/harddisk2" 				>> /tmp/local/sbin/pre-mount
		else
			echo -e "ln -s /tmp/mnt/disc1_1 /tmp/harddisk2" 				>> /tmp/local/sbin/pre-mount
		fi
	fi
	echo -e "swapon -a" 																>> /tmp/local/sbin/pre-mount
	echo -e "sleep 1" 																>> /tmp/local/sbin/pre-mount
	echo -e "for i in \`awk '/ext3/{print(\$1)}' /etc/fstab\` ; do" 	>> /tmp/local/sbin/pre-mount
	echo -e "  if [ -b \$i ] ; then" 											>> /tmp/local/sbin/pre-mount
	echo -e "      grep -q \$i /proc/mounts || e2fsck -p \$i 2>&1 | logger -t e2fsck" >> /tmp/local/sbin/pre-mount
	echo -e "   else" 																>> /tmp/local/sbin/pre-mount
	echo -e "      logger -t fstab \"\$i is not attached\"" 				>> /tmp/local/sbin/pre-mount
	echo -e "  fi" 																	>> /tmp/local/sbin/pre-mount
	echo -e "done" 																	>> /tmp/local/sbin/pre-mount
	echo -e "" 																			>> /tmp/local/sbin/pre-mount

	echo
	if [ "$v_lan" = "RU" ]; then echo -e -n "$a_white Создание "; else echo -e -n "$a_white Writing "; fi; echo -e "post-mount$a_std"
	echo -e "#!/bin/sh" 																>> /tmp/local/sbin/post-mount
	echo -e "/opt/etc/init.d/rc.unslung start" 								>> /tmp/local/sbin/post-mount
	echo -e "" 																			>> /tmp/local/sbin/post-mount
	
	echo
	if [ "$v_lan" = "RU" ]; then echo -e -n "$a_white Создание "; else echo -e -n "$a_white Writing "; fi; echo -e "pre-shutdown$a_std"
	wget $repaddress_url/_pre-shutdown_new -O /tmp/local/sbin/pre-shutdown
	wget $repaddress_url/signal_and_wait.inc.sh -O /tmp/local/sbin/signal_and_wait.inc.sh
	
	echo
	if [ "$v_lan" = "RU" ]; then echo -e -n "$a_white Создание "; else echo -e -n "$a_white Writing "; fi; echo -e "post-firewall$a_std"
	echo -e "#!/bin/sh" 																>> /tmp/local/sbin/post-firewall
	echo -e "" 																			>> /tmp/local/sbin/post-firewall
	
	echo
	if [ "$v_lan" = "RU" ]; then echo -e -n "$a_white Создание "; else echo -e -n "$a_white Writing "; fi; echo -e "ez-setup$a_std"
	echo -e "#!/bin/sh" 																>> /tmp/local/sbin/ez-setup
	echo -e "" 																			>> /tmp/local/sbin/ez-setup
	echo -e "#/usr/bin/logger -t ez-setup \"Key pressed\"" 				>> /usr/local/sbin/ez-setup
	echo -e "#if [ \`/usr/sbin/wl radio\` = \"0x0001\" ] ; then"		>> /usr/local/sbin/ez-setup
	echo -e "#	/usr/sbin/wl radio on" 											>> /usr/local/sbin/ez-setup
	echo -e "#	/usr/bin/logger -t ez-setup \"Started WiFi\""			>> /usr/local/sbin/ez-setup
	echo -e "#else" 																	>> /usr/local/sbin/ez-setup
	echo -e "#	/usr/sbin/wl radio off" 										>> /usr/local/sbin/ez-setup
	echo -e "#	/usr/bin/logger -t ez-setup \"WiFi STOP\"" 				>> /usr/local/sbin/ez-setup
	echo -e "#fi" 																		>> /usr/local/sbin/ez-setup
	echo -e ""																			>> /usr/local/sbin/ez-setup

	chmod +x /tmp/local/sbin/*
	sleep 2

	#Создание файла Fstab
	echo
	if [ "$v_lan" = "RU" ]; then echo -e "$a_white Создание Fstab ...$a_std"; else echo -e "$a_white Writing fstab depending to your memory ...$a_std"; fi
	echo -e "#device Mountpoint FStype Options Dump Pass#" 								>> /etc/fstab
	if [ "$veros" = "2.6" ] ; then
		echo -e "/dev/sda1 none swap sw 0 0" 													>> /etc/fstab
		echo -e "/dev/sda2 /opt ext3 rw,noatime 1 1" 										>> /etc/fstab
		echo -e "/dev/sda3 /tmp/mnt/disca_3 ext3 rw,noatime 1 1" 						>> /etc/fstab
		if [ "$v_hard" = "TWO" ] ; then
			echo -e "/dev/sdb1 /tmp/mnt/discb_1 ext3 rw,noatime 1 1" 					>> /etc/fstab
		fi
	else
		echo -e "/dev/discs/disc0/part1 none swap sw 0 0" 									>> /etc/fstab
		echo -e "/dev/discs/disc0/part2 /opt ext3 rw,noatime 1 1" 						>> /etc/fstab
		echo -e "/dev/discs/disc0/part3 /tmp/mnt/disc0_3 ext3 rw,noatime 1 1" 		>> /etc/fstab
		if [ "$v_hard" = "TWO" ] ; then
			echo -e "/dev/discs/disc1/part1 /tmp/mnt/disc1_1 ext3 rw,noatime 1 1" 	>> /etc/fstab
		fi
	fi
	
	#Формирование разделов HDD
	if [ "$format" = "FORMAT" ] ;  then
		echo
		if [ "$v_lan" = "RU" ]; then 
			echo -e "$a_white Формирование таблицы разделов ...$a_std"
		else
			echo -e "$a_white Preparing partition table ...$a_std"
		fi
		partdelete="o\n"
		partdata1="n\np\n1\n\n+256M\n"
		partdata2="n\np\n2\n\n+1024M\n"
		partdata3="n\np\n3\n\n\n"
		partdata4="t\n1\n82\nw"
		echo -e "$partdelete$partdata1$partdata2$partdata3$partdata4" > parttable
		if [ "$veros" = "2.6" ] ; then
			fdisk  /dev/sdb < parttable
		else
			fdisk /dev/discs/disc0/disc < parttable
		fi
		sleep 2
	fi

	#создания раздела подкачки
	echo
	if [ "$v_lan" = "RU" ]; then 
		echo -e "$a_white Создание$a_green SWAP$a_white раздела ...$a_std"
	else
		echo -e "$a_white Prepare$a_green SWAP$a_white for use ...$a_std"
	fi
	if [ "$veros" = "2.6" ] ; then
		mkswap /dev/sdb1
	else
		mkswap /dev/discs/disc0/part1
	fi
	sleep 2
	
	# Подключение раздела подкачки
	echo
	if [ "$v_lan" = "RU" ]; then 
		echo -e "$a_white Подключение$a_green SWAP$a_white раздела  ...$a_std"
	else 
		echo -e "$a_white Turn$a_green SWAP$a_white on ...$a_std"
	fi
	if [ "$veros" = "2.6" ] ; then
		swapon /dev/sdb1
	else
		swapon /dev/discs/disc0/part1
	fi
	sleep 1

	#Форматирование файловой системы (раздел OPT)
	echo
	if [ "$v_lan" = "RU" ]; then echo -e "$a_white Форматирование разделов $a_green OPT$a_white ...$a_std"
		else echo -e "$a_white Formatting $a_green OPT$a_white partition ...$a_std"
	fi
	
	if [ "$veros" = "2.6" ] ; then
		mke2fs -j /dev/sdb2
	else
		mke2fs -j /dev/discs/disc0/part2
	fi
	sleep 1

	#Форматирование файловой системы (раздел DATA)
	if [ "$format" = "FORMAT" ] ;  then
		echo
		if [ "$v_lan" = "RU" ]; then echo -e "$a_white Форматирование разделов $a_green DATA$a_white ...$a_std"
			else echo -e "$a_white Formatting $a_green DATA$a_white partition ...$a_std"
		fi
		
		if [ "$veros" = "2.6" ] ; then
			mke2fs -j /dev/sdb3
		else
			mke2fs -j /dev/discs/disc0/part3
		fi
		sleep 1
	fi

	mkdir -p /tmp/harddisk
	
	#Монтирование файловой системы
	echo
	if [ "$v_lan" = "RU" ]; then echo -e "$a_white Монтирование $a_green OPT$a_white и $a_green DATA$a_white ...$a_std"
		else echo "$a_whiteMounting $a_green /opt$a_white and$a_green /data$a_white partition to$a_green /tmp/harddisk$a_white which is a symlink to $a_green/tmp/mnt/disca_3$a_white ...$a_std"
	fi
	if [ "$veros" = "2.6" ] ; then
		mount /dev/sdb2 /opt
		mount /dev/sdb3 /tmp/harddisk
	else
		mount /dev/discs/disc0/part2 /opt
		mount /dev/discs/disc0/part3 /tmp/harddisk
	fi

	if [ "$v_hard" = "TWO" ] ; then
		if [ "$format" = "FORMAT" ] ;  then
			#Создание разделов HDD
			partdelete_two="o\n"
			partdata1_two="n\np\n1\n\n\nw"
			echo
			echo -e "$partdelete_two$partdata1_two" > parttable
			if [ "$veros" = "2.6" ] ; then
				fdisk  /dev/sdb < parttable
			else
				fdisk /dev/discs/disc1/disc < parttable
			fi
			sleep 2

			#Форматирование файловой системы
			echo
			echo -e "$a_red FORMAT$a_white the$a_green DATA$a_white partition on$a_green SECOND HDD$a_white ...$a_std"
			if [ "$veros" = "2.6" ] ; then
				mke2fs -j /dev/sdb1
			else
				mke2fs -j /dev/discs/disc1/part1
			fi
			sleep 1
		fi
		
		#Монтирование файловой системы
		echo
		if [ "$veros" = "2.6" ] ; then
			echo "mounting /data partition to /tmp/mnt/discb_1 ..."
			mount /dev/sdb1 /tmp/mnt/discb_1
		else
			echo "mounting /data partition to /tmp/mnt/disc1_1 ..."
			mount /dev/discs/disc1/part1 /tmp/mnt/disc1_1
		fi
	fi


	echo
	echo "creating directory /opt/etc/init.d ....."
	mkdir -p /opt/etc/init.d
	
	echo
	echo "writing rc.unslung"
	wget $repaddress_url/rc.unslung -O /opt/etc/init.d/rc.unslung 
	chmod +x /opt/etc/init.d/rc.unslung

	echo
	echo "preparing /opt/tmp/ipkg for ipkg-opt installation....."
	echo "Configuring temp area"
	mkdir -p /opt/tmp/ipkg
	chmod 777 /opt/tmp/ipkg
	chmod 777 /tmp
	
	echo
	echo "changing to directory /opt/tmp/ipkg......"
	cd /opt/tmp/ipkg
	sleep 2

	config_ipkg
	
	#------------------ Installing Midnight Commander (mc) -----------------
	echo
	echo -e "$a_white $INSTAL $a_green Midnight Commander (mc)$a_white ...$a_std"
	wget $repaddress_url/libiconv_1.11-2_mipsel.ipk -O libiconv_1.11-2_mipsel.ipk
	ipkg install libiconv_1.11-2_mipsel.ipk
	ipkg install mc
	wget $repaddress_url/mc.menu -O /tmp/local/root/.mc.menu
	cp /tmp/local/root/.mc.menu /tmp/local/.mc.menu
	cp /tmp/local/root/.mc.menu /tmp/local/sbin/.mc.menu
	
	# ----------------
	echo
	echo "mkdir /opt/var/log ..."
	mkdir -p /opt/var/log
	sleep 2
	
	#------------------ Installing Job scheduler (Cron or Crond) ----------------
	echo
	echo -e "$a_white $INSTAL $a_green $v_cron$a_white ...$a_std" 

	if [ "$v_cron" = "cron" ] ;  then
		ipkg install cron
		sleep 5
		rm -f /opt/etc/crontab
		echo -e "SHELL=/bin/sh" 																		>> /opt/etc/crontab
		echo -e "PATH=/opt/bin:/opt/sbin:/sbin:/bin:/usr/sbin:/usr/bin:/opt/usr/bin:/opt/usr/sbin" >> /opt/etc/crontab
		echo -e "MAILTO=\"\"" 																			>> /opt/etc/crontab
		echo -e "HOME=/" 																					>> /opt/etc/crontab
		echo -e "# ------------------------------------------------------------- #" 	>> /opt/etc/crontab
		echo -e "# Syntax for lines is : minute hour day month dayofweek command #" 	>> /opt/etc/crontab
		echo -e "# ------------------------------------------------------------- #" 	>> /opt/etc/crontab
		echo -e "*/1 * * * * $rootname /opt/bin/run-parts /opt/etc/cron.1min" 			>> /opt/etc/crontab
		echo -e "*/5 * * * * $rootname /opt/bin/run-parts /opt/etc/cron.5mins" 			>> /opt/etc/crontab
		echo -e "01 * * * * $rootname /opt/bin/run-parts /opt/etc/cron.hourly" 			>> /opt/etc/crontab
		echo -e "02 4 * * * $rootname /opt/bin/run-parts /opt/etc/cron.daily" 			>> /opt/etc/crontab
		echo -e "22 4 * * 0 $rootname /opt/bin/run-parts /opt/etc/cron.weekly" 			>> /opt/etc/crontab
		echo -e "42 4 1 * * $rootname /opt/bin/run-parts /opt/etc/cron.monthly" 		>> /opt/etc/crontab
		echo -e "" 																							>> /opt/etc/crontab
		chmod 600 /opt/etc/crontab
		wget $repaddress_url/S10cron -O /opt/etc/init.d/S10cron
		chmod +x /opt/etc/init.d/S10cron
	else
		mkdir -p /tmp/etc/crontabs
		echo -e "# ------------------------------------------------------------- #" 	>> /var/spool/cron/crontabs/$rootname
		echo -e "# Syntax for lines is : minute hour day month dayofweek command #" 	>> /var/spool/cron/crontabs/$rootname
		echo -e "# ------------------------------------------------------------- #" 	>> /var/spool/cron/crontabs/$rootname
		echo -e "*/1 * * * * /opt/bin/run-parts /opt/etc/cron.1min" 						>> /var/spool/cron/crontabs/$rootname
		echo -e "*/5 * * * * /opt/bin/run-parts /opt/etc/cron.5mins" 						>> /var/spool/cron/crontabs/$rootname
		echo -e "01 * * * * /opt/bin/run-parts /opt/etc/cron.hourly" 						>> /var/spool/cron/crontabs/$rootname
		echo -e "02 4 * * * /opt/bin/run-parts /opt/etc/cron.daily" 						>> /var/spool/cron/crontabs/$rootname
		echo -e "22 4 * * 0 /opt/bin/run-parts /opt/etc/cron.weekly" 						>> /var/spool/cron/crontabs/$rootname
		echo -e "42 4 1 * * /opt/bin/run-parts /opt/etc/cron.monthly" 						>> /var/spool/cron/crontabs/$rootname
		echo -e ""																							>> /var/spool/cron/crontabs/$rootname
		chmod 600 /var/spool/cron/crontabs/$rootname
		echo -e "/var/spool/cron/crontabs/$rootname" >> /usr/local/.files 
		wget $repaddress_url/S10crond -O /opt/etc/init.d/S10crond
		chmod +x /opt/etc/init.d/S10crond
	fi

	wget $repaddress_url/run-parts -O /opt/bin/run-parts
	chmod +x /opt/bin/run-parts
	
	mkdir -p /opt/etc/cron.1min
	mkdir -p /opt/etc/cron.5mins
	mkdir -p /opt/etc/cron.hourly
	mkdir -p /opt/etc/cron.daily
	mkdir -p /opt/etc/cron.weekly
	mkdir -p /opt/etc/cron.monthly
	
	#------------------ Installing$a_green Lighttpd and PHP -------------------
	echo; echo -e "$a_white $INSTAL $a_green Lighttpd$a_white and$a_green PHP$a_white ...$a_std"
	ipkg install lighttpd
	ipkg install php-fcgi
	ipkg install php-gd
	ipkg install php-mbstring
	ipkg install openssh-sftp-server
	ipkg install sqlite
	ipkg install microperl
	ipkg install tar
	ipkg install nano
	echo 
	if [ "$v_lan" = "RU" ]; then	echo -e "$a_white Загрузка конфигурации веб-сервера .........$a_std"; else echo -e "$a_white download of webserver config.........$a_std"; fi
	wget $repaddress_url/_lighttpd.conf -O /opt/etc/lighttpd/lighttpd.conf
	wget $repaddress_url/S45php -O /opt/etc/init.d/S45php
	chmod +x /opt/etc/init.d/S45php
	wget $repaddress_url/php.ini -O /opt/etc/php.ini
	wget $repaddress_url/iconv.so -O /opt/lib/php/extensions/iconv.so
	chmod +x /opt/lib/php/extensions/iconv.so
	mkdir -p /opt/var/log/lighttpd
	echo
	if [ "$v_lan" = "RU" ]; then	echo -e -n "$a_white Настройка"; else echo -e -n "$a_white Configuring"; fi;  echo -e "$a_green lighttpd$a_std"
	echo "$var_usr:$var_pwd" > /opt/etc/lighttpd/lighttpd-plain.user
	echo ; echo
	if [ "$v_lan" = "RU" ]; then
		echo -e "      $a_red Внимание !!!$a_green Изменен порт доступа к ВЕБ-странице роутера с 80 на $a_red 8080$a_std"
		echo -e "                $a_green РОУТЕР ДОСТУПЕН ТОЛЬКО ПО АДРЕСУ - http://my.router:8080$a_std"
	else
		echo -e "      $a_red Attention !!!$a_green Reconfiguring webinterface access to port$a_red 8080$a_std"
		echo -e "                $a_green YOUR ROUTER IS ONLY REACHABLE ON PORT 8080$a_std"
	fi
	nvram set http_lanport=8080
	nvram commit
	sleep 2
	echo "# port HTTP" >> /usr/local/sbin/post-firewall
	
	if [  "$v_inte" = "YES"  ] ; then
		echo "iptables -I INPUT -p tcp --dport 80 -j ACCEPT" >> /usr/local/sbin/post-firewall
	else
		echo "# iptables -I INPUT -p tcp --dport 80 -j ACCEPT" >> /usr/local/sbin/post-firewall
	fi
	echo "" >> /usr/local/sbin/post-firewall
	echo; echo
	
	#------------------ Installing SAMBA  ---------------------
	echo;	echo -e "$a_white $INSTAL $a_white SAMBA$a_green $v_samb$a_std"
	
	nvram set usb_smbenable_x=0
	nvram set usb_smbcset_x=utf8
	nvram commit

	mkdir -p /opt/etc/samba
	mkdir -p /tmp/harddisk/data
	mkdir -p /tmp/harddisk/data/Document
	mkdir -p /tmp/harddisk/data/Distrib
	mkdir -p /tmp/harddisk/data/Archive
	mkdir -p /tmp/harddisk/data/Video
	mkdir -p /tmp/harddisk/data/Music
	mkdir -p /tmp/harddisk/data/Temp

	if [ "$v_samb" = "v.2" ] ; then
		wget $repaddress_url/S97Samba -O /opt/etc/init.d/S97Samba
		chmod +x /opt/etc/init.d/S97Samba
	else
		/usr/sbin/smbd -D -s /opt/etc/samba/smb.conf             
		/usr/sbin/nmbd -D -s /opt/etc/samba/smb.conf

		ipkg install samba35
	
		wget $repaddress_url/S08samba_35 -O /opt/etc/init.d/S08samba
		chmod +x /opt/etc/init.d/S08samba

		smbpasswd -a -n $var_usr
		ipkg install samba35-swat
		sed -i "s|root|$rootname|"  /opt/etc/xinetd.d/swat ;# сменить пользователя в случае отличия от "root"
		rm -f /opt/etc/init.d/S20dbus
	fi
	echo; echo "Configuring SAMBA"
	echo "[global]"											>> /opt/etc/samba/smb.conf
	echo "interfaces = $iplan_pr"							>> /opt/etc/samba/smb.conf
	echo "guest account = nobody" 						>> /opt/etc/samba/smb.conf
	echo "security = share"									>> /opt/etc/samba/smb.conf
	echo "guest ok = yes"									>> /opt/etc/samba/smb.conf
	echo "log level = 1"										>> /opt/etc/samba/smb.conf
	echo "max log size = 100"								>> /opt/etc/samba/smb.conf
	echo "encrypt passwords = yes"						>> /opt/etc/samba/smb.conf
	echo "dns proxy = no"									>> /opt/etc/samba/smb.conf
	echo "workgroup = $wkgrp"								>> /opt/etc/samba/smb.conf
	echo "netbios name = $hname"							>> /opt/etc/samba/smb.conf
	echo "server string = $iplanaddr"					>> /opt/etc/samba/smb.conf; ##комментарий к серверу

# Кодировки
#character set = UTF-8
#display charset = UTF-8
# Принтерные опции
#disable spoolss = Yes
#show add printer wizard = No
#load printers = No

	if [ "$v_samb" = "v.2" ] ; then
		echo "guest only = yes"								>> /opt/etc/samba/smb.conf
		# Слушаем только заданные интерфейсы
		echo "bind interfaces only = yes"				>> /opt/etc/samba/smb.conf; ##если хочется работать только в LAN    
		echo "browseable = yes"								>> /opt/etc/samba/smb.conf
		echo "client code page = 866"						>> /opt/etc/samba/smb.conf
		echo "coding system = utf8"						>> /opt/etc/samba/smb.conf
	else
		echo "config file = /opt/etc/samba/smb.conf"	>> /opt/etc/samba/smb.conf
		echo "guest only = no"								>> /opt/etc/samba/smb.conf
		echo "local master = yes"							>> /opt/etc/samba/smb.conf; ## чтобы соглашался быть мастер-браузером рабочей группы
		echo "short preserve case = yes"					>> /opt/etc/samba/smb.conf
		echo "dos charset = UTF-8"							>> /opt/etc/samba/smb.conf
		echo "unix charset = UTF-8"						>> /opt/etc/samba/smb.conf
		echo "display charset = UTF-8"					>> /opt/etc/samba/smb.conf
		echo "wins support = yes"							>> /opt/etc/samba/smb.conf
		echo "time server = yes"							>> /opt/etc/samba/smb.conf
	fi
	echo "[Data]"												>> /opt/etc/samba/smb.conf
	echo "path=/tmp/harddisk/data"						>> /opt/etc/samba/smb.conf
	echo "writeable = yes"									>> /opt/etc/samba/smb.conf
	echo "browseable = yes"									>> /opt/etc/samba/smb.conf
	echo "force user = $rootname"							>> /opt/etc/samba/smb.conf
	echo "[www$]"												>> /opt/etc/samba/smb.conf
	echo "path=/opt/share/www"								>> /opt/etc/samba/smb.conf
	echo "writeable = yes"									>> /opt/etc/samba/smb.conf
	echo "browseable = yes"									>> /opt/etc/samba/smb.conf
	echo "force user = $rootname"							>> /opt/etc/samba/smb.conf
	echo "[DlEngine]"                 					>> /opt/etc/samba/smb.conf
	echo "path=/tmp/harddisk/downloads" 				>> /opt/etc/samba/smb.conf
	echo "writeable = yes"         						>> /opt/etc/samba/smb.conf
	echo "browseable = yes"        						>> /opt/etc/samba/smb.conf
	echo "force user = $rootname"  						>> /opt/etc/samba/smb.conf
	if [ "$v_hard" = "TWO" ] ; then
		echo "[HDD-2]"											>> /opt/etc/samba/smb.conf
		if [ "$veros" = "2.6" ] ; then
			echo "path=/tmp/mnt/discb_1"					>> /opt/etc/samba/smb.conf
		else
			echo "path=/tmp/mnt/disc1_1"					>> /opt/etc/samba/smb.conf
		fi
		echo "writeable = yes"								>> /opt/etc/samba/smb.conf
		echo "browseable = yes"								>> /opt/etc/samba/smb.conf
		echo "force user = $rootname"						>> /opt/etc/samba/smb.conf
	fi
	#----------------------------------------------------------
		
	ipkg install coreutils
	ipkg install procps
	ipkg install grep
	ipkg install screen
	ipkg install gawk
	echo; echo "Configuring .profile"
	echo "export TERMINFO=\"/opt/share/terminfo\""				>> /tmp/local/root/.profile
	echo "export TERM=\"xterm\""										>> /tmp/local/root/.profile
	echo "alias mc=\"mc -c\""											>> /tmp/local/root/.profile
	echo "export LANG=\"ru_RU.UTF-8\""								>> /tmp/local/root/.profile
	echo "export LC_ALL=\"ru_RU.UTF-8\""							>> /tmp/local/root/.profile
	echo "alias ls=\"ls --color=auto -la\""						>> /tmp/local/root/.profile
	echo "alias ps=\"ps axf\""											>> /tmp/local/root/.profile
	echo "alias df=\"df -h\""											>> /tmp/local/root/.profile
	echo "alias rt='su -c \"screen -r\" p2p'" 					>> /tmp/local/root/.profile
	echo "chmod a+rw \`tty\`" 											>> /tmp/local/root/.profile
	echo "stty start undef" 											>> /tmp/local/root/.profile
	echo "stty stop undef" 												>> /tmp/local/root/.profile
	chmod +x /tmp/local/root/.profile
	
	echo "Configuring .files"
	echo "/etc/fstab" 									>> /usr/tmp/local/.files
	echo "/etc/passwd" 									>> /usr/tmp/local/.files
	echo "/etc/group" 									>> /usr/tmp/local/.files
	
	echo; echo "Configuring post-mount settings"
	echo "rm /opt/var/run/*.pid" 									>> /usr/local/sbin/post-mount

	#------------------ Installing Download Engine -------------------------
	echo; echo -e "$a_white $INSTAL $a_green Download Engine$a_white ...$a_std"

	ipkg install wget-ssl

	wget $repaddress_url/dlengine_2.0-19_mipsel.ipk -O dlengine_2.0-19_mipsel.ipk
	ipkg install dlengine_2.0-19_mipsel.ipk
	sed -i 's/EXITEMPTYQUEUE=NO/EXITEMPTYQUEUE=YES/' /opt/etc/dlengine.conf
	rm /opt/etc/init.d/S90busybox_httpd
	rm /opt/etc/httpd.conf
	echo -e "$a_white $INSTAL $PLUGIN $a_green dlengine_letitbit.net(2011-03-05)$a_white ...$a_std"
	wget $repaddress_url/letitbit.net.sh -O /opt/var/lib/dlengine/plugins/letitbit.net.sh
	sleep 5
	echo; echo -e "$a_white $INSTAL $PLUGIN $a_green dlengine_depositfiles.com(2011-06-12)$a_white ...$a_std"
	wget $repaddress_url/depositfiles.com.sh -O /opt/var/lib/dlengine/plugins/depositfiles.com.sh
	chmod +x /opt/var/lib/dlengine/plugins/*.*
	sleep 5

	#------------------ Ftp ---------------------
	echo; echo -e "$a_white Configuring FTP\033[0m"
	mkdir -p /tmp/harddisk/ftp_pub
	mkdir -p /tmp/harddisk/ftp_pvt

	#------------------ Installing and configuring QuiXplorer ---------------------
	echo; echo -e "$a_white $INSTAL  $a_green QuiXplorer$a_white ...$a_std"
	wget $repaddress_url/ftp.tar.gz -O ftp.tar.gz
	tar -xzf ftp.tar.gz -C /opt/share/www/
	sleep 5

	#------------------ Installing syslog-ng ------------------------------
	echo; echo -e "$a_white $INSTAL $a_green syslog-ng$a_white ...$a_std"
	ipkg install syslog-ng
	mkdir -p /opt/var/log/archive/
	wget $repaddress_url/S01syslog-ng -O /opt/etc/init.d/S01syslog-ng
	chmod +x /opt/etc/init.d/S01syslog-ng
	wget $repaddress_url/syslog-ng.conf -O /opt/etc/syslog-ng/syslog-ng.conf
	wget $repaddress_url/archivelog.sh -O /opt/etc/cron.hourly/archivelog.sh
	chmod +x /opt/etc/cron.hourly/archivelog.sh

	#------------------ Installing status ------------------------------
	rm /opt/share/www/lighttpd/index.html
	wget $repaddress_url/_index.txt -O /opt/share/www/lighttpd/index.html
	sed -i "s|my.router|$iplanaddr|g" /opt/share/www/lighttpd/index.html
	
	#------------------ Installing eAccelerator --------------------
	echo; echo -e "$a_white $INSTAL $a_green eAccelerator$a_white ...$a_std"
	ipkg install eaccelerator
	mkdir -p /tmp/harddisk/eaccelerator
	chmod 777 /tmp/harddisk/eaccelerator
	wget $repaddress_url/eaccelerator.ini -O /opt/etc/php.d/eaccelerator.ini
	sleep 2

	#------------------ Installing System Info & IPKG  ---------------------------
	echo; echo -e "$a_white $INSTAL $a_green System Info & IPKG (The ipkg web frontend)$a_white ...$a_std"
	wget $repaddress_url/cgi-bin.tar.gz -O cgi-bin.tar.gz
	tar -xzf cgi-bin.tar.gz -C /opt/share/www/
	rm -f cgi-bin.tar.gz
	
	wget $repaddress_url/package.cgi -O /opt/share/www/cgi-bin/package.cgi
	chmod +x /opt/share/www/cgi-bin/info.cgi
	chmod +x /opt/share/www/cgi-bin/package.cgi
	sleep 2
	echo; echo
	echo "Install script version $number_ver -= Copyright (c) 2011 RunG (Yuri Ch.) =-" > /opt/share/www/.ver

	#-------------------------------------------------------
	wget $repaddress_url/checkHDD.sh -O /tmp/local/checkHDD.sh
	chmod +x /tmp/local/checkHDD.sh

	echo -e "### Ограничиваем доступ ребенку." 																>> /tmp/local/sbin/post-firewall
	echo -e "### Во время действия летнего времени срабатывает на 1 час позже:" 					>> /tmp/local/sbin/post-firewall
	echo -e "### Создаем новую цепочку, дропаем в ней все по умолчанию." 							>> /tmp/local/sbin/post-firewall
	echo -e "### Заворачиваем на нее все интернет-пакеты ребенка" 										>> /tmp/local/sbin/post-firewall
	echo -e "#iptables -N CHILD" 																					>> /tmp/local/sbin/post-firewall
	echo -e "#iptables -A CHILD -j DROP" 																		>> /tmp/local/sbin/post-firewall
	echo -e "#iptables -I FORWARD 1 -m mac --mac-source xx:xx:xx:xx:xx:xx -o ppp0 -j CHILD" 	>> /tmp/local/sbin/post-firewall
	echo -e "#iptables -I FORWARD 1 -m mac --mac-source xx:xx:xx:xx:xx:xx -o ppp0 -j CHILD" 	>> /tmp/local/sbin/post-firewall
	echo -e "#iptables -I FORWARD 1 -m mac --mac-source xx:xx:xx:xx:xx:xx -o ppp0 -j CHILD" 	>> /tmp/local/sbin/post-firewall
	echo -e "### Включаем ребенку интернет по времени" 													>> /tmp/local/sbin/post-firewall
	echo -e "#iptables -I CHILD 1 -m time --timestart 09:00:00 --timestop 20:00:00 --weekdays Sun,Mon,Tue,Wed,Thu,Fri,Sat -j RETURN" >> /tmp/local/sbin/post-firewall
	echo -e "" 																											>> /tmp/local/sbin/post-firewall

	wget $repaddress_url/inet_auto.sh -O /tmp/local/inet_auto.sh
	wget $repaddress_url/inet_on.sh -O /tmp/local/inet_on.sh
	wget $repaddress_url/inet_off.sh -O /tmp/local/inet_off.sh
	chmod +x /tmp/local/inet_auto.sh
	chmod +x /tmp/local/inet_on.sh
	chmod +x /tmp/local/inet_off.sh

	if [ ! -e "/tmp/etc/scdumm.conf" ]; then ## создать файл-флаг
		echo "verscript=$number_ver" >> /tmp/etc/scdumm.conf
	fi

fi

#########################################################################################
##                                   UPDATE                                            ##
#########################################################################################

if [ $format = "UPDATE" ]; then config_ipkg; fi

#########################################################################################
##                                   PROGRAM                                           ##
#########################################################################################

#необходимо - Обновление Transmission до версии 2.31-1  - http://wl500g.info/showpost.php?p=231996&postcount=92

if [ "$mv_tor" = "x" ] ; then
	if [ "$cs_tr" = "1" ]; then
		echo -e "$a_white $INSTAL $a_green Transmission (BitTorrent Client) $a_white $mt_tor ...$a_std"
		ipkg install transmission
		echo -e "$a_white Configuration Transmission$a_std"
		wget $repaddress_url/S99trans -O /opt/etc/init.d/S99trans
		sleep 2
		chmod +x /opt/etc/init.d/S99trans
		sleep 2
		echo "# port for Transmission (BitTorrent client)" 				>> /usr/local/sbin/post-firewall
		echo "iptables -I INPUT -p tcp --dport 65534 -j ACCEPT"			>> /usr/local/sbin/post-firewall
		echo "iptables -I INPUT -p udp --dport 65534 -j ACCEPT"			>> /usr/local/sbin/post-firewall
		echo "iptables -I INPUT -p tcp --dport 51413 -j ACCEPT"			>> /usr/local/sbin/post-firewall
		if [  "$v_inte" = "YES"  ] ; then
			echo "iptables -I INPUT -p tcp --dport 9091 -j ACCEPT"		>> /usr/local/sbin/post-firewall
		else
			echo "# iptables -I INPUT -p tcp --dport 9091 -j ACCEPT"		>> /usr/local/sbin/post-firewall
		fi
		echo "" 																			>> /usr/local/sbin/post-firewall

		echo -e "/opt/etc/init.d/S99trans stop"								>> /usr/local/sbin/ez-setup
		echo -e "sleep 5"																>> /usr/local/sbin/ez-setup
		echo -e "halt"																	>> /usr/local/sbin/ez-setup
		echo -e ""																		>> /usr/local/sbin/ez-setup

		mkdir -p /tmp/harddisk/torrent/work
		mkdir -p /tmp/harddisk/torrent/.config/
		mkdir -p /tmp/harddisk/torrent/.config/blocklists
		mkdir -p /tmp/harddisk/torrent/.config/resume
		mkdir -p /tmp/harddisk/torrent/.config/torrents
		chmod -R 777 /tmp/harddisk/torrent/

		wget $repaddress_url/_settings.json -O /tmp/harddisk/torrent/.config/settings.json
		sleep 2
		echo "    \"rpc-username\": \"$var_usr\"," >> /tmp/harddisk/torrent/.config/settings.json
		echo "    \"rpc-password\": \"$var_pwd\"," >> /tmp/harddisk/torrent/.config/settings.json
		echo "    \"upload-slots-per-torrent\": 14" >> /tmp/harddisk/torrent/.config/settings.json
		echo "}" >> /tmp/harddisk/torrent/.config/settings.json
		echo -e "$a_white Writing file favicon.ico for Transmission\033[0m"
		wget $repaddress_url/trans_favicon.ico -O /opt/share/transmission/web/favicon.ico
		sleep 5
		if [ "$v_hard" = "TWO" ]; then
			if [ "$veros" = "2.6" ]; then
				mkdir -p /tmp/mnt/discb_1/torrent/work
			else
				mkdir -p /tmp/mnt/disc1_1/torrent/work
			fi
		fi
	elif [ "$cs_tr" = "2"  ]; then
		echo -e "$a_white $INSTAL $a_green rTorrent (BitTorrent Client) $a_white ...$a_std"
		ipkg install rtorrent

		wget $repaddress_url/rtorrent.conf -O /opt/etc/rtorrent.conf
		chmod a+r /opt/etc/rtorrent.conf
		cp /opt/etc/rtorrent.conf ~/.rtorrent.rc

		echo -e "$a_white $INSTAL$a_green ruTorrent 3.3 & plugins$a_white ...$a_std"
		wget $repaddress_url/rutorrent-3.3.tar.gz -O rutorrent-3.3.tar.gz
		tar -xzf rutorrent-3.3.tar.gz -C /opt/share/www/
		rm -f rutorrent-3.3.tar.gz

		wget $repaddress_url/plugins-3.3.tar.gz -O plugins-3.3.tar.gz     #new
		tar -xzf plugins-3.3.tar.gz -C /opt/share/www/rutorrent/ 			   #new
		rm -f plugins-3.3.tar.gz
		sleep 10

		echo "# port for rTorrent"													>> /usr/local/sbin/post-firewall
		echo "iptables -I INPUT -p tcp -m tcp --dport 51778 -j ACCEPT"	>> /usr/local/sbin/post-firewall
		echo ""																			>> /usr/local/sbin/post-firewall

		echo -e "/opt/etc/init.d/S99rtorrent stop" 							>> /usr/local/sbin/ez-setup
		echo -e "sleep 5" 															>> /usr/local/sbin/ez-setup
		echo -e "halt" 																>> /usr/local/sbin/ez-setup
		echo -e "" 																		>> /usr/local/sbin/ez-setup

		echo -e "$a_white Configuring system for ruTorrent startup\033[0m"
		if [ "$veros" = "2.6" ] ; then
			wget $repaddress_url/26_S99rtorrent -O /opt/etc/init.d/S99rtorrent
			echo "chmod 666 /dev/null" 					>> /usr/local/sbin/post-boot
			echo "" 												>> /usr/local/sbin/post-boot
		else
			wget $repaddress_url/S99rtorrent_new -O /opt/etc/init.d/S99rtorrent
		fi
		chmod +x /opt/etc/init.d/S99rtorrent

		chmod a+x /opt/bin/rtorrent
		mkdir -p /tmp/harddisk/torrent
		mkdir -p /tmp/harddisk/torrent/dl
		mkdir -p /tmp/harddisk/torrent/work
		mkdir -p /tmp/harddisk/torrent/session

		ipkg install adduser
		echo "Adding user p2p"
		mkdir -p /tmp/local/root
		mkdir -p /opt/home/p2p
		adduser -D --home /opt/home/p2p p2p
		chown p2p /opt/home/p2p
		chown p2p /tmp/harddisk/torrent/*

		cp /tmp/local/root/.profile /opt/home/p2p/.profile
		chown p2p /opt/home/p2p/.profile

		echo "rm /tmp/harddisk/torrent/session/*.lock" 		>> /tmp/local/sbin/post-mount
		echo "cp /opt/etc/rtorrent.conf ~/.rtorrent.rc" 	>> /tmp/local/sbin/post-mount
		echo "" 															>> /tmp/local/sbin/post-mount
		
		if [ "$v_hard" = "TWO" ] ; then
			if [ "$veros" = "2.6" ] ; then
				mkdir -p /tmp/mnt/discb_1/torrent
				mkdir -p /tmp/mnt/discb_1/torrent/dl
				mkdir -p /tmp/mnt/discb_1/torrent/work
				mkdir -p /tmp/mnt/discb_1/torrent/session
				chown p2p /tmp/mnt/discb_1/torrent/*
			else
				mkdir -p /tmp/mnt/disc1_1/torrent
				mkdir -p /tmp/mnt/disc1_1/torrent/dl
				mkdir -p /tmp/mnt/disc1_1/torrent/work
				mkdir -p /tmp/mnt/disc1_1/torrent/session
				chown p2p /tmp/mnt/disc1_1/torrent/*
			fi
		fi
		ipkg install which
	fi
	echo "[Torrent]"										>> /opt/etc/samba/smb.conf
	echo "path=/tmp/harddisk/torrent"				>> /opt/etc/samba/smb.conf
	echo "writeable = yes"								>> /opt/etc/samba/smb.conf
	echo "browseable = yes"								>> /opt/etc/samba/smb.conf
	echo "force user = $rootname"						>> /opt/etc/samba/smb.conf
	
	if [ "$routerid" = "RT-N16" ]; then
		echo -e "#correct error in torrent - \"page allocation failure\"" 	>> /tmp/local/sbin/post-boot
		echo -e "echo 16384 > /proc/sys/vm/min_free_kbytes"					>> /tmp/local/sbin/post-boot
		echo -e ""																				>> /tmp/local/sbin/post-boot
	fi
fi
#----------------------------------------------------------------------------
if [ "$mv_sts" = "x" ] ;  then
	echo -e "$a_white $INSTAL $a_green Site Status Router$a_white ...$a_std"
	ipkg install python

	mkdir /opt/share/www/status
	if [ $v_hard = "ONE" ] ; then
		wget $repaddress_url/status_one.tar.gz -O status.tar.gz
		tar -xzf status.tar.gz -C /opt/share/www/
		sleep 5
		if [ $veros = 2.6 ] ; then
			wget $repaddress_url/n16_info_collector_one.py -O /opt/etc/cron.5mins/info_collector.py
			chmod +x /opt/etc/cron.5mins/info_collector.py
		else
			wget $repaddress_url/info_collector_one.py -O /opt/etc/cron.5mins/info_collector.py
			chmod +x /opt/etc/cron.5mins/info_collector.py
		fi
	else
		wget $repaddress_url/status_two.tar.gz -O status.tar.gz
		tar -xzf status.tar.gz -C /opt/share/www/
		sleep 5
		if [ $veros = 2.6 ] ; then
			wget $repaddress_url/n16_info_collector_two.py -O /opt/etc/cron.5mins/info_collector.py
			chmod +x /opt/etc/cron.5mins/info_collector.py
			else
			wget $repaddress_url/info_collector_two.py -O /opt/etc/cron.5mins/info_collector.py
			chmod +x /opt/etc/cron.5mins/info_collector.py
		fi
		chmod +x /opt/share/www/status/nod32_show/nod32_show.php
	fi
	sed -i "s|http://wl500g.info/showthread.php?t=21889|http://rung.narod.ru|" /opt/share/www/status/index.php
	sed -i "s|ftp://core.dumped.ru/|http://wl500g.googlecode.com/|" /opt/share/www/status/index.php
	sed -i "s|192.168.1.1|$iplanaddr|g" /opt/share/www/status/index.php
	sleep 5
fi
#----------------------------------------------------------------------------
if [ "$mv_rrd" = "x" ] ;  then
	echo -e "$a_white $INSTAL $a_green RRD$a_white ...$a_std"
	ipkg install rrdtool
	if [ "$cs_rr" = "1" ] ;  then   # old
		if [ $format = "UPDATE" ]; then
			rm -rf /opt/traffic
			rm -rf /opt/share/www/rrd-new/traffic
			rm -rf /opt/share/www/rrd-new
			rm -rf /opt/traffic/rrd.sh
			rm -rf /opt/etc/cron.5mins/update_stat.sh
			sed -i "s|/rrd-new/index.cgi|/rrd|" /opt/share/www/status/index.php
		fi
		
		mkdir -p /opt/usr/bin/
		wget $repaddress_url/rrdtool.sh -O /opt/usr/bin/rrdtool.sh
		chmod +x /opt/usr/bin/rrdtool.sh
		/opt/usr/bin/rrdtool.sh
		echo "Configuring rrd"
		echo "#!/bin/sh" 																	> /opt/etc/cron.5mins/rrdrun.sh
		echo "PATH=/opt/sbin:/opt/bin:/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/opt" >> /opt/etc/cron.5mins/rrdrun.sh
		echo "/opt/usr/bin/rrdtool.sh >> /opt/var/log/rrdtool.log 2>&1" 	>> /opt/etc/cron.5mins/rrdrun.sh
		chmod +x /opt/etc/cron.5mins/rrdrun.sh
	else  # rrd-new
		if [ $format = "UPDATE" ]; then
			rm -rf /opt/etc/cron.5mins/rrdrun.sh
			rm -rf /opt/usr/bin/rrdtool.sh
			rm -rf /opt/etc/cron.5mins/rrdrun.sh
		fi
		
		mkdir -p /opt/traffic
		mkdir -p /opt/share/www/rrd-new
		mkdir -p /opt/share/www/rrd-new/traffic
		wget $repaddress_url/rrd.sh -O /opt/traffic/rrd.sh
		chmod +x /opt/traffic/rrd.sh
		/opt/traffic/rrd.sh
		echo "Configuring rrd-new"
		echo "#!/bin/sh"																	> /opt/etc/cron.5mins/update_stat.sh
		echo "PATH=/opt/sbin:/opt/bin:/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/opt" >> /opt/etc/cron.5mins/update_stat.sh
		echo "/opt/traffic/rrd.sh >> /dev/null" 									>> /opt/etc/cron.5mins/update_stat.sh
		chmod +x /opt/etc/cron.5mins/update_stat.sh
		sed -i "s|/rrd|/rrd-new/index.cgi|" /opt/share/www/status/index.php
		sed -i "s|RRD|RRD-NEW|" /opt/share/www/status/index.php
		#echo "<?php header('Location: index.cgi');exit;?>" > /opt/share/www/rrd-new/index.php ##проба
		fi
fi
#----------------------------------------------------------------------------
if [ "$mv_nod" = "x" ] ;  then
	echo -e "$a_white $INSTAL $a_green NOD32upd server$a_white ...$a_std"
	ipkg install unrar
	mkdir -p /opt/share/www/eset_upd
	wget $repaddress_url/nod32upd -O /opt/share/www/nod32upd
	wget $repaddress_url/nod32upd.conf -O /opt/share/www/nod32upd.conf
	chmod +x /opt/share/www/nod32upd
	touch /opt/etc/cron.hourly/nod32upd.sh
	echo "#!/bin/sh" 																	> 	/opt/etc/cron.hourly/nod32upd.sh
	echo "cd /opt/share/www && ./nod32upd" 									>> /opt/etc/cron.hourly/nod32upd.sh
	if [ "$mv_sts" = "x" ] ;  then
		echo "sleep 10" 																>> /opt/etc/cron.hourly/nod32upd.sh
		echo "cd /opt/share/www/status/nod32_show && ./nod32_show.php"	>> /opt/etc/cron.hourly/nod32upd.sh
	fi
	chmod +x /opt/etc/cron.hourly/nod32upd.sh
	
	#rm /opt/var/run/nod32upd.pid
	#cd /opt/share/www && ./nod32upd
	#cd /opt/share/www/status/nod32_show && ./nod32_show.php
fi
#----------------------------------------------------------------------------
if [ "$mv_pvx" = "x" ] ;  then
	echo -e "$a_white $INSTAL $a_green Privoxy$a_white and$a_green Polipo$a_white ...$a_std"
	touch /opt/var/log/privoxy.log
	ipkg install privoxy
	mkdir -p /tmp/harddisk/Cache
	chmod 777 /tmp/harddisk/Cache
	wget $repaddress_url/S60privoxy -O /opt/etc/init.d/S60privoxy
	chmod +x /opt/etc/init.d/S60privoxy
	echo "Add config and filtres for Privoxy"
	wget $repaddress_url/privoxy.tar.gz -O privoxy.tar.gz
	tar -xzf privoxy.tar.gz -C /opt/etc/
	sed -i "s|192.168.1.1|$iplanaddr|"  /opt/etc/privoxy/config
		
	sleep 10
	
	ipkg install polipo
	touch /opt/var/log/polipo.log
	mkdir -p /opt/etc/polipo
	wget $repaddress_url/forbidden -O /opt/etc/polipo/forbidden
	wget $repaddress_url/options -O /opt/etc/polipo/options
	wget $repaddress_url/S70polipo -O /opt/etc/init.d/S70polipo
	chmod +x /opt/etc/init.d/S70polipo

	rm -f /opt/etc/polipo/config
	echo "proxyAddress = $iplanaddr" 					>> /opt/etc/polipo/config 			;# адрес вашей машины по формату xx.xx.xx.xx
	echo "proxyPort = 8123" 								>> /opt/etc/polipo/config			;# По умолчанию polipo использует порт 8123
	echo "allowedClients = 127.0.0.1, $network" 		>> /opt/etc/polipo/config			;# адреса машин имеющих доступ к прокси 127.0.0.1, xx.xx.xx.xx
	echo "parentProxy = $iplanaddr:8118" 				>> /opt/etc/polipo/config
	echo "chunkHighMark = 819200" 						>> /opt/etc/polipo/config
	echo "objectHighMark = 128" 							>> /opt/etc/polipo/config
	echo "diskCacheRoot = /tmp/mnt/harddisk/Cache" 	>> /opt/etc/polipo/config			;# расположение кеша
	echo "diskCacheTruncateTime = 30d" 					>> /opt/etc/polipo/config
	echo "diskCacheUnlinkTime = 90d" 					>> /opt/etc/polipo/config
	echo "diskCacheTruncateSize = 2048 MB" 			>> /opt/etc/polipo/config
	echo "dnsQueryIPv6 = no" 								>> /opt/etc/polipo/config
	echo "dnsUseGethostbyname = true" 					>> /opt/etc/polipo/config			;# Используем встроенный резолвер
	echo "dnsMaxTimeout = 3" 								>> /opt/etc/polipo/config
	echo "disableServersList = false" 					>> /opt/etc/polipo/config
	echo "diskCacheWriteoutOnClose = 32768" 			>> /opt/etc/polipo/config
	echo "maxDiskEntries = 4096" 							>> /opt/etc/polipo/config
	echo "disableIndexing = false" 						>> /opt/etc/polipo/config
	echo "maxConnectionRequests = 512" 					>> /opt/etc/polipo/config
	echo "maxDiskCacheEntrySize = -1" 					>> /opt/etc/polipo/config
	echo "daemonise = true" 								>> /opt/etc/polipo/config
	
#	#make privoxy intercepting proxy thru polipo and tranparent rules
#	sed -i 's/proxyPort = 8123/proxyPort = 8118/' /opt/etc/polipo/config
#	sed -i 's/parentProxy = 192.168.1.1:8118/ /' /opt/etc/polipo/config
#
#	sed -i 's/listen-address  192.168.1.1:8118/listen-address  192.168.1.1:8123/' /opt/etc/privoxy/config
#	echo -e "forward  /  192.168.1.1:8118" >> /opt/etc/privoxy/config
#	sed -i 's/accept-intercepted-requests 0/accept-intercepted-requests 1/' /opt/etc/privoxy/config
#	echo -e "modprobe ipt_REDIRECT" >> /tmp/local/sbin/post-firewall
#	echo -e "iptables -t nat -i br0 -A PREROUTING -p tcp --dport 80 -j REDIRECT --to-port 8123" >> /tmp/local/sbin/post-firewall
	
	sleep 10
	
	
	
#else
	#Stunnel и 3proxy http://bruteforcer.ru/index.php/2009/11/30/narushaem-zaprety-s-pomoshhyu-stunnel-i-3proxy/
#	ipkg install stunnel
#	#cd /opt/etc/stunnel
#	# удаляем сертификать по-умолчанию
#	rm -f /opt/etc/stunnel/stunnel.pem
#	mv stunnel-cert.cnf stunnel-cert.conf
#	# генерируем сертификат
#	openssl req -new -x509 -days 365 -nodes -config /opt/etc/stunnel/stunnel-cert.conf -out /opt/etc/stunnel/stunnel.pem -keyout /opt/etc/stunnel/stunnel.pem
#	rm -f /opt/etc/stunnel/stunnel.rnd
#	chown -R nobody:nobody /opt/etc/stunnel
#	chmod 600 /opt/etc/stunnel/*
fi
#----------------------------------------------------------------------------
## в планах добавить http://max-3000.com/
if [ "$mv_cms" = "x" ] ; then
	if [ "$cs_cm" = "1" ] ; then
		echo -e "$a_white $INSTAL $a_green Sawanna CMS$a_white ...$a_std"
		wget $repaddress_url/sawanna.tar.gz -O sawanna.tar.gz
		tar -xzf sawanna.tar.gz -C /opt/share/
		sleep 5
		wget $repaddress_url/data.db -O /opt/share/data.db
		chmod 777 /opt/share/data.db
		chmod 777 /opt/share/www/upload
      ##  надо попробовать внедрить это http://wl500g.info/showpost.php?p=237332&postcount=109
		#ipkg install sendmail
		#ipkg install esmtp
		sleep 10
	elif [ "$cs_cm" = "2" ] ; then
		echo -e "$a_white $INSTAL $a_green phpSQLiteCMS$a_white ...$a_std"
		wget $repaddress_url/site.tar.gz -O site.tar.gz
		tar -xzf site.tar.gz -C /opt/share/www/
		sleep 10
		wget $repaddress_url/index.tar.gz -O index.tar.gz
		tar -xzf index.tar.gz -C /opt/share/
		wget $repaddress_url/site_lighttpd.conf -O /opt/etc/lighttpd/lighttpd.conf
		echo -e "$a_white Add WYSIWYG editor FCKeditor ...\033[0m"
		wget $repaddress_url/FCKeditor_2.6.5.tar.gz -O FCKeditor_2.6.5.tar.gz
		tar -xzf FCKeditor_2.6.5.tar.gz -C /opt/share/www/site/cms/modules/
		sleep 15
		wget $repaddress_url/FCKeditor_config.tar.gz -O FCKeditor_config.tar.gz
		tar -xzf FCKeditor_config.tar.gz -C /opt/share/www/site/cms/modules/fckeditor/editor/filemanager/connectors/
		chmod +x /opt/share/www/site/cms/modules/fckeditor/editor/filemanager/connectors/php/config.php
		sleep 10
		chmod 777 /opt/share/www/site/cache
		chmod 777 /opt/share/www/site/files
		chmod 777 /opt/share/www/site/images
		chmod 770 /opt/share/www/site/templates_c
		mkdir /opt/share/www/site/files/file
		mkdir /opt/share/www/site/files/image
		mkdir /opt/share/www/site/files/media
		mkdir /opt/share/www/site/files/flash
		chmod +x /opt/share/www/site/files/file
		chmod +x /opt/share/www/site/files/image
		chmod +x /opt/share/www/site/files/media
		chmod +x /opt/share/www/site/files/flash
		sleep 10
	fi
fi
#----------------------------------------------------------------------------
if [  "$mv_vns" = "x"  ] ; then
	echo -e "$a_white $INSTAL $a_green vnStat v.1.5.1$a_white ...$a_std"
	
	ipkg -force-reinstall install vnstat

	rm -rf /opt/etc/cron.d/

	vnstat -u -i eth1  > /dev/null
	vnstat -u -i vlan1 > /dev/null
	vnstat -u -i br0   > /dev/null
	vnstat -u -i ppp0  > /dev/null

	rm -rf /opt/share/www/vnstat
	
	wget $repaddress_url/vnstat_php_frontend-1.5.1.tar.gz -O vnstat.tar.gz
	tar -xzf vnstat.tar.gz -C /opt/share/www/
	
	echo "#!/bin/sh" 																									> /opt/etc/cron.5mins/vnstat.sh
	echo "" 																												>>/opt/etc/cron.5mins/vnstat.sh
	echo "# run vnstat update every 5 minutes if installed" 												>>/opt/etc/cron.5mins/vnstat.sh
	echo "if [ -x /opt/bin/vnstat ] && [ \`ls /opt/var/lib/vnstat/ | wc -l\` -ge 1 ]; then" 	>>/opt/etc/cron.5mins/vnstat.sh
	echo "	/opt/bin/vnstat -u" 																					>>/opt/etc/cron.5mins/vnstat.sh
	echo "fi" 																											>>/opt/etc/cron.5mins/vnstat.sh
	chmod +x /opt/etc/cron.5mins/vnstat.sh
   
	#language
	if [ "$v_lan" = "RU" ]; then
		wget $repaddress_url/ru.php -O /opt/share/www/vnstat/lang/ru.php
		chmod 777 /opt/share/www/vnstat/lang/ru.php
		sed -i "s|en_US.UTF-8|ru_RU.UTF-8|g" /opt/share/www/vnstat/config.php
		sed -i "s|'nl';|'ru';|g" /opt/share/www/vnstat/config.php
		wget $repaddress_url/verdana.ttf -O /opt/share/www/vnstat/VeraBd.ttf
	else
		sed -i "s|'nl';|'en';|g" /opt/share/www/vnstat/config.php
	fi

	#correction code
	sed -i "s|'bytes in'|T('bytes in')|" /opt/share/www/vnstat/graph.php
	sed -i "s|'bytes out'|T('bytes out')|" /opt/share/www/vnstat/graph.php

	if [ "$routerid" = "WL500W" ]; then 		## это старая версия 1.4.1, небыло времени переработать
		echo -e "$a_white Configuration vnStat for WL500W$a_std"
		vnstat -u -i eth0 > /dev/null
		vnstat -u -i eth2 > /dev/null
		wget $repaddress_url/vnstat_w.tar.gz -O vnstat_w.tar.gz
		tar -xzf vnstat_w.tar.gz -C /opt/share/www/
	fi
	# ifconfig | grep Ethernet | awk '{print $1}'

fi
#----------------------------------------------------------------------------
if [ "$mv_upn" = "x" ] ; then
	if [ "$cs_up" = "1" ] ; then
		#http://www.twonkyforum.com/mediawiki/index.php/Asus_Routers_-_Oleg_FW#Installing_Twonky_Server_on_Asus_routers"
		
		echo -e "$a_white $INSTAL $a_green TwonkyMedia server $a_white  v.6.0.30 ...$a_std"

		wget $repaddress_url/twonkymedia-asus-6.0.30.tar.gz -O /opt/tmp/twonky.tar.gz
		tar -xzf /opt/tmp/twonky.tar.gz -C /tmp/harddisk/
		sleep 5
		rm /opt/tmp/twonky.tar.gz
	
		cd /tmp/harddisk/twonkymedia
		chmod +x twonkym* cgi-bin/* plugins/* resources/*

		wget $repaddress_url/S99twonkymedia -O /opt/etc/init.d/S99twonkymedia
		chmod +x /opt/etc/init.d/S99twonkymedia
	
		##установка видео-транскодинга 
		#ipkg install flac ffmpeg imagemagick
		#echo "/opt/bin" > /tmp/harddisk/twonkymedia/cgi-bin/ffmpeg.location
		#echo "/opt/bin" > /tmp/harddisk/twonkymedia/cgi-bin/convert.location
		#echo "/opt/bin" > /tmp/harddisk/twonkymedia/cgi-bin/flac.location

		echo -e "# port for TwonkyMedia" 												>> /usr/local/sbin/post-firewall
		echo -e "ipaddr=\$(nvram get wan0_ipaddr)" 									>> /usr/local/sbin/post-firewall
		echo -e "iptables -I INPUT -s 63.241.31.144 -d \$ipaddr -j DROP"		>> /usr/local/sbin/post-firewall
		echo -e "iptables -I OUTPUT -s \$ipaddr -d 63.241.31.144 -j DROP" 	>> /usr/local/sbin/post-firewall
		if [  $v_inte = "YES"  ] ; then
			echo -e "iptables -I INPUT -p tcp --dport 9000 -j ACCEPT" 			>> /usr/local/sbin/post-firewall
		else
			echo -e "#iptables -I INPUT -p tcp --dport 9000 -j ACCEPT" 			>> /usr/local/sbin/post-firewall
		fi
		echo -e "" 																				>> /usr/local/sbin/post-firewall
	elif [ "$cs_up" = "2" ] ; then
		echo -e "$a_white $INSTAL $a_green MediaTomb$a_white ...$a_std"
		ipkg install mediatomb
		mkdir -p /opt/etc/mediatomb
		mkdir -p /usr/local/root/.mediatomb
		/bin/sed -i 's/MT_USER="roFot"/MT_USER="$rootname"/' /opt/etc/mediatomb.conf
		/bin/sed -i 's/MT_ENABLE=false/MT_ENABLE=true/' /opt/etc/default/mediatomb
		cd /opt/share/mediatomb
		cat sqlite3.sql | sqlite3 mediatomb.db
		mv mediatomb.db /opt/etc/mediatomb/
		echo "# port for Mediatomb" >> /usr/local/sbin/post-firewall
		if [  $v_inte = "YES"  ] ; then
			echo "iptables -I INPUT -p tcp --dport 50500 -j ACCEPT" >> /usr/local/sbin/post-firewall
		else
			echo "#iptables -I INPUT -p tcp --dport 50500 -j ACCEPT" >> /usr/local/sbin/post-firewall
		fi
		echo -e "" 																	>> /usr/local/sbin/post-firewall
		/opt/etc/init.d/S90mediatomb start
	elif [ "$cs_up" = "3" ];  then
		echo -e "\033[32;40;1m $INSTAL  Ushare Media Server...\033[0m"
		ipkg install ushare
		wget $repaddress_url/ushare.conf -O /opt/etc/ushare.conf
		if [  $v_inte = "YES"  ] ; then
			echo "# for Ushare (Media Server)" >> /tmp/local/sbin/post-firewall
			echo "iptables -I INPUT -p tcp --dport 49200 -j ACCEPT" >> /tmp/local/sbin/post-firewall
			echo "iptables -I INPUT -p udp --dport 49200 -j ACCEPT" >> /tmp/local/sbin/post-firewall
		else
			echo "# for Ushare (Media Server)" >> /tmp/local/sbin/post-firewall
			echo "#iptables -I INPUT -p tcp --dport 49200 -j ACCEPT" >> /tmp/local/sbin/post-firewall
			echo "#iptables -I INPUT -p udp --dport 49200 -j ACCEPT" >> /tmp/local/sbin/post-firewall
		fi
	fi
fi
#----------------------------------------------------------------------------
if [  "$mv_img" = "x"  ] ; then
	echo -e "$a_white $INSTAL $a_green Flash Photo Gallery$a_white ...$a_std"
	wget $repaddress_url/photo.tar.gz -O photo.tar.gz
	tar -xzf photo.tar.gz -C /opt/share/www/
	sleep 20
	chmod 777 /opt/share/www/photo/imagevue/config/
	chmod 777 /opt/share/www/photo/content/
	chmod 777 /opt/share/www/photo/imagevue/themes/
	chmod 777 /opt/share/www/photo/imagevue/language/
fi
#----------------------------------------------------------------------------
if [ "$mv_icq" = "x" ] ; then
	echo -e "$a_white $INSTAL $a_green Web2ICQ$a_white ...$a_std"
	wget $repaddress_url/site_lighttpd.conf -O /opt/etc/lighttpd/lighttpd.conf
	wget $repaddress_url/icq.tar.gz -O icq.tar.gz
	tar -xzf icq.tar.gz -C /opt/share/www/
	sleep 10
fi
#----------------------------------------------------------------------------
if [ "$mv_sms" = "x" ] ; then
	echo -e "$a_white $INSTAL $a_green SMS messages$a_white ...$a_std"
	wget $repaddress_url/sendsms.tar.gz -O sendsms.tar.gz
	tar -xzf sendsms.tar.gz -C /opt/etc/
	rm -f sendsms.tar.gz
	
	wget $repaddress_url/send_end.php -O /opt/etc/sendsms/send_end.php
	cat /tmp/local/root/send.php /opt/etc/sendsms/send_end.php > /opt/etc/sendsms/send.php
	rm -f /opt/etc/sendsms/send_end.php					# удаление временного файла
	rm -f /tmp/local/root/send.php						# удаление временного файла
	
	chmod +x /opt/etc/sendsms/send.php
	chmod +x /opt/etc/sendsms/class.mrim.php
	chmod 666 /opt/etc/sendsms/login.txt
	chmod 666 /opt/etc/sendsms/base.db
	chmod 666 /opt/etc/sendsms/smsqueue
	echo "sleep 10s" 																			>> /usr/local/sbin/post-mount
	echo "ipaddr=\$(nvram get wan0_ipaddr)" 											>>  /usr/local/sbin/post-mount
	echo "#/opt/etc/sendsms/send.php $phone \"Router '$(nvram get lan_hostname)' (\$ipaddr) is loaded\"" 	>>  /usr/local/sbin/post-mount
	echo "/opt/etc/sms_py/send.py $phone \"Router '$(nvram get lan_hostname)' (\$ipaddr) is loaded\"" 		>>  /usr/local/sbin/post-mount
	echo "" 																						>>  /usr/local/sbin/post-mount

	if [ "$mv_tor" = "x" ] && [ "$cs_tr" = "2"  ] ; then   ## если установлен rTorrent
		echo "#on_finished=send_finish_sms,\"execute = /opt/etc/sendsms/send.php,$phone,\$d.get_name=.\"" 	>> /opt/etc/rtorrent.conf
		echo "on_finished=send_finish_sms,\"execute = /opt/etc/sms_py/send.py,$phone,\$d.get_name=.\"" 		>> /opt/etc/rtorrent.conf
	fi

	if [ "$mv_nod" = "x" ] ;  then
		echo "NTEL=$phone" 																	>> /opt/share/www/nod32upd.conf
	fi
	sleep 5
	
	echo -e "$a_white $INSTAL $a_green Send SMS-Web$a_white ...$a_std"
	ipkg install python3
	mkdir -p /opt/share/www/sms
	chmod 775 /opt/share/www/sms
	mkdir -p /opt/etc/sms_py
	wget $repaddress_url/site_lighttpd.conf -O /opt/etc/lighttpd/lighttpd.conf
	
	wget $repaddress_url/sms_py.tar.gz -O sms_py.tar.gz
	tar -xzf sms_py.tar.gz -C /opt/etc/
	rm sms_py.tar.gz
	
	rm -f /opt/etc/sms_py/store.py
	echo -e "" 														>> /opt/etc/sms_py/store.py
	echo -e "logins = [$mail_smspy]" 						>> /opt/etc/sms_py/store.py
	echo -e "passes = [$pass_smspy]" 						>> /opt/etc/sms_py/store.py
	echo -e "log_filename = \"/opt/var/log/sms.log\"" 	>> /opt/etc/sms_py/store.py
	echo -e "" 														>> /opt/etc/sms_py/store.py
	chmod +x /opt/etc/sms_py/*.*
	
	## отложенная отправка
	# Пример отправки  - ./sendtime.py 8 23 7916xxxxxxx message
	# Первый параметр - час, когда смс может приходить; второй - когда уже смс приходить не может.
#	if [ $cron_opt = "yes" ] ;  then
#		echo -e "0 * * * *   /opt/etc/sms_py/smscron.sh"	>> /opt/etc/crontab
#	else
#		echo -e "0 * * * *   /opt/etc/sms_py/smscron.sh" 	>> /var/spool/cron/crontabs/$rootname
#	fi
	
	wget $repaddress_url/sms.tar.gz -O sms.tar.gz
	tar -xzf sms.tar.gz -C /opt/share/www
	chmod +x /opt/share/www/sms/sendFromWeb.py
	sleep 5
	
	echo -e "#!/bin/sh" 																	>  /opt/etc/sms_py/host_ping.sh
	echo -e "" 																				>> /opt/etc/sms_py/host_ping.sh
	echo -e "HOST=\$1" 																	>> /opt/etc/sms_py/host_ping.sh
	echo -e "TMPFILE=/tmp/ping.tmp" 													>> /opt/etc/sms_py/host_ping.sh
	echo -e "" 																				>> /opt/etc/sms_py/host_ping.sh
	echo -e "ping -c 1 -w 5 \$HOST &>/dev/null" 									>> /opt/etc/sms_py/host_ping.sh
	echo -e "" 																				>> /opt/etc/sms_py/host_ping.sh
	echo -e "if [ \$? -ne 0 ] ; then" 												>> /opt/etc/sms_py/host_ping.sh
	echo -e "  if [ ! -e \$TMPFILE ] ; then" 										>> /opt/etc/sms_py/host_ping.sh
	echo -e "    touch \$TMPFILE" 													>> /opt/etc/sms_py/host_ping.sh
	echo -e "    #/opt/etc/sms/send.php $phone \"Ping is down '$(nvram get lan_hostname)' -> \$HOST\"" 	>> /opt/etc/sms_py/host_ping.sh
	echo -e "    /opt/etc/sms_py/send.py $phone \"Ping is down '$(nvram get lan_hostname)' -> \$HOST\"" >> /opt/etc/sms_py/host_ping.sh
	echo -e " fi" 																			>> /opt/etc/sms_py/host_ping.sh
	echo -e "else" 																		>> /opt/etc/sms_py/host_ping.sh
	echo -e "  if [ -e \$TMPFILE ] ; then" 										>> /opt/etc/sms_py/host_ping.sh
	echo -e "    rm \$TMPFILE" 														>> /opt/etc/sms_py/host_ping.sh
	echo -e "    #/opt/etc/sms/send.php $phone \"Ping is up '$(nvram get lan_hostname)' -> \$HOST\"" 	>> /opt/etc/sms_py/host_ping.sh
	echo -e "    /opt/etc/sms_py/send.py $phone \"Ping is up '$(nvram get lan_hostname)' -> \$HOST\"" 	>> /opt/etc/sms_py/host_ping.sh
	echo -e "  fi" 																		>> /opt/etc/sms_py/host_ping.sh
	echo -e "fi" 																			>> /opt/etc/sms_py/host_ping.sh
	echo -e "" 																				>> /opt/etc/sms_py/host_ping.sh
	chmod +x /opt/etc/sms_py/host_ping.sh

	if [ "$sms_ping" != "no" ] ;  then
		echo -e "#!/bin/sh" 															>  /opt/etc/cron.1min/ping.sh
		echo -e "" 																		>> /opt/etc/cron.1min/ping.sh
		echo -e "cd /opt/etc/sms_py && ./host_ping.sh \"$sms_ping\"" 	>> /opt/etc/cron.1min/ping.sh
		echo -e "" 																		>> /opt/etc/cron.1min/ping.sh
		chmod +x /opt/etc/cron.1min/ping.sh
	fi
	
	sleep 2
fi
#----------------------------------------------------------------------------
if [ "$mv_ado" = "x" ] ; then
	echo -e "$a_white $INSTAL $a_green Automatic DOwnload System$a_white (ADOS)$a_white ...$a_std"
	mkdir -p /opt/share/www/ados
	wget $repaddress_url/ados.tar.gz -O ados.tar.gz
	tar -xzf ados.tar.gz -C /opt/share/www/
	sleep 10
	wget $repaddress_url/axel.tgz -O axel.tgz
	tar -xzf axel.tgz -C /opt/bin/
	sleep 2
	chmod 0755 /opt/bin/axel
	mkdir -p /tmp/harddisk/ados
	mkdir -p /tmp/harddisk/ados/admin
	mkdir -p /tmp/harddisk/ados/admin/archives
	mkdir -p /tmp/harddisk/ados/admin/images
	mkdir -p /tmp/harddisk/ados/admin/music
	mkdir -p /tmp/harddisk/ados/admin/programs
	mkdir -p /tmp/harddisk/ados/admin/video
	mkdir -p /tmp/harddisk/ados/_all
	mkdir -p /tmp/harddisk/ados/_tmp
	mkdir -p /tmp/harddisk/ados/_log
	chmod 0777 /tmp/harddisk/ados/*
	wget $repaddress_url/ados.sh -O /opt/etc/cron.1min/ados.sh
	chmod +x /opt/etc/cron.1min/ados.sh
	echo "Configuring samba."
	echo "[ADOS]"                 		>> /opt/etc/samba/smb.conf
	echo "path=/tmp/harddisk/ados"    	>> /opt/etc/samba/smb.conf
	echo "writeable = yes"         		>> /opt/etc/samba/smb.conf
	echo "browseable = yes"        		>> /opt/etc/samba/smb.conf
	echo "force user = $rootname"  		>> /opt/etc/samba/smb.conf
fi
#----------------------------------------------------------------------------
if [ "$mv_frm" = "x" ] ; then
	echo -e "$a_white $INSTAL $a_green ExBB FM 1.0 RC1$a_white (Exclusive Bulletin Board) ...$a_std"
	mkdir -p /opt/share/www/forum
	wget $repaddress_url/forum.tar.gz -O forum.tar.gz
	tar -xzf forum.tar.gz -C /opt/share/www/
	sleep 10
fi
#----------------------------------------------------------------------------
if [ "$mv_mld" = "x" ] ; then
	echo -e "$a_white $INSTAL $a_green MLDonkey Lite$a_white (Donkey, BitTorrent, FileTP) ...$a_std"
	ipkg install file
	wget $repaddress_url/mlnet.byte -O /opt/bin/mlnet.byte
	chmod +x /opt/bin/mlnet.byte
	echo "mldonkey:x:100:100:mldonkey:/tmp/harddisk:/bin/sh" >> /etc/passwd
	echo "users:x:100:" >> /etc/group
	mkdir -p /tmp/harddisk/.mldonkey/
	chown mldonkey.users /tmp/harddisk/.mldonkey/
	su - mldonkey sh -c "
	HOME=/tmp/harddisk/ TMPDIR=/tmp/harddisk/.mldonkey/tmp \
	/opt/bin/mlnet.byte -allowed_ips '127.0.0.0/8 $network' &"
	sleep 20
	killall mlnet.byte
	sleep 2
	sed -i 's/max_hard_download_rate = 50/max_hard_download_rate = 0/' /tmp/harddisk/.mldonkey/downloads.ini
	sed -i 's/loop_delay = 5/loop_delay = 20/' /tmp/harddisk/.mldonkey/downloads.ini
	wget $repaddress_url/mldonkey.sh -O /tmp/harddisk/mldonkey.sh
	chmod +x /tmp/harddisk/mldonkey.sh
	wget $repaddress_url/lang_ru_mldonkey.tar.gz -O lang_ru_mldonkey.tar.gz
	tar -xzf lang_ru_mldonkey.tar.gz -C /tmp/harddisk
	sleep 2
	echo "Configuring SAMBA"
	echo "[MLDonkey]"                 				>> /opt/etc/samba/smb.conf
	echo "path=/tmp/harddisk/.mldonkey/incoming"	>> /opt/etc/samba/smb.conf
	echo "writeable = yes"         					>> /opt/etc/samba/smb.conf
	echo "browseable = yes"        					>> /opt/etc/samba/smb.conf
	echo "force user = $rootname"  					>> /opt/etc/samba/smb.conf
	
	echo "# ports for MLDonkey" 																	>> /usr/local/sbin/post-firewall
	echo "BITTORRENT_PORT=6881" 																	>> /usr/local/sbin/post-firewall
	echo "EDONKEY_PORT=12276" 																		>> /usr/local/sbin/post-firewall
	echo "OVERNET_PORT=7805" 																		>> /usr/local/sbin/post-firewall
	echo "## MLDonkey acting as BitTorrent client" 											>> /usr/local/sbin/post-firewall
	echo "iptables -I INPUT -p tcp --dport \$BITTORRENT_PORT -j ACCEPT" 				>> /usr/local/sbin/post-firewall
	echo "iptables -I INPUT -p tcp --dport \$((BITTORRENT_PORT + 1)) -j ACCEPT" 	>> /usr/local/sbin/post-firewall
	echo "## MLDonkey acting as EDonkey client" 												>> /usr/local/sbin/post-firewall
	echo "iptables -I INPUT -p tcp --dport \$EDONKEY_PORT -j ACCEPT" 					>> /usr/local/sbin/post-firewall
	echo "iptables -I INPUT -p udp --dport \$((EDONKEY_PORT + 4)) -j ACCEPT" 		>> /usr/local/sbin/post-firewall
	echo "## MLDonkey acting as Overnet client" 												>> /usr/local/sbin/post-firewall
	echo "iptables -I INPUT -p tcp --dport \$OVERNET_PORT -j ACCEPT" 					>> /usr/local/sbin/post-firewall
	echo "iptables -I INPUT -p udp --dport \$OVERNET_PORT -j ACCEPT" 					>> /usr/local/sbin/post-firewall
	echo "" 																								>> /usr/local/sbin/post-firewall
fi
#----------------------------------------------------------------------------
if [  "$mv_sql" = "x"  ]; then
	echo -e "$a_white $INSTAL $a_green MySQL & phpMyAdmin$a_white ...$a_std"
	ipkg install php-curl php-dev php-imap php-ldap php-mysql php-pear php-xmlrpc phpmyadmin
	sed -i 's/;include_path = ".:\/php\/includes"/include_path = ".:\/opt\/lib\/php\/extentions:\/opt\/share\/pear"/' /opt/etc/php.ini
	wget $repaddress_url/phpmyadmin.tar.gz -O phpmyadmin.tar.gz
	tar -xzf phpmyadmin.tar.gz -C /opt/share/www
	rm /opt/var/lib/mysql/mysql/*.*
	rmdir /opt/var/lib/mysql/mysql
	/opt/bin/mysql_install_db
	chown -R root:root /opt/var/lib/mysql
	/opt/etc/init.d/S70mysqld start
	sleep 10
	
fi
#----------------------------------------------------------------------------
if [  "$mv_dbh" = "x"  ]; then
	echo -e "$a_white $INSTAL $a_green DBHub$a_white ...$a_std"
	wget $repaddress_url/dbhub_0.450-2_mipsel.ipk -O dbhub_0.450-2_mipsel.ipk
	ipkg install dbhub_0.450-2_mipsel.ipk
	rm /opt/etc/init.d/rc.dbhub
	wget $repaddress_url/S98dbhub -O /opt/etc/init.d/S98dbhub
	chmod +x /opt/etc/init.d/S98dbhub
	mkdir -p /tmp/harddisk/dbhub
	wget $repaddress_url/dbhub.tar.gz -O dbhub.tar.gz
	tar -xzf dbhub.tar.gz -C /tmp/harddisk/dbhub
	echo "# port for DBHub" >> /usr/local/sbin/post-firewall
	if [  $v_inte = "YES"  ] ; then
		echo "iptables -I INPUT -p tcp --dport 411 -j ACCEPT"		>> /usr/local/sbin/post-firewall
	else
		echo "#iptables -I INPUT -p tcp --dport 411 -j ACCEPT"	>> /usr/local/sbin/post-firewall
	fi
	echo "" 																		>> /usr/local/sbin/post-firewall
	sleep 2

	echo -e "$a_white Installing$a_green RRDtool DC++ Stats & Scripts (Perl)$a_white ...$a_std"
	ipkg install rrdtool
	wget $repaddress_url/perl_scripts.tar.gz -O perl_scripts.tar.gz
	tar -xzf perl_scripts.tar.gz -C /tmp/harddisk/dbhub/.dbhub
	sed -i 's/show_lastmsgs = 1/show_lastmsgs = 0/'  /tmp/harddisk/dbhub/.dbhub/config
	chmod +x /tmp/harddisk/dbhub/.dbhub/scripts/*.*
	mkdir -p /opt/share/www/dchub
	mkdir -p /opt/share/www/dchub/img
	sleep 10
fi
#----------------------------------------------------------------------------
if [  "$mv_mdc" = "x"  ]; then
	echo -e "$a_white $INSTAL $a_green microdc2$a_white ...$a_std"
	ipkg install microdc2
	mkdir -p /opt/etc/.microdc2
	mkdir -p /tmp/harddisk/microdc
	mkdir -p /tmp/harddisk/microdc/dowsloads
	wget $repaddress_url/microdc2_config -O /opt/etc/.microdc2/config
	wget $repaddress_url/dcs -O /opt/bin/dcs
	wget $repaddress_url/dc -O /opt/bin/dc
	chmod +x /opt/bin/dcs
	chmod +x /opt/bin/dc
	sleep 10
fi
#----------------------------------------------------------------------------
if [  "$mv_vpn" = "x"  ]; then
	echo -e "$a_white $INSTAL $a_green OpenVPN$a_white ...$a_std"
	ipkg install openvpn
	rm -rf /opt/etc/openvpn
	rm -rf /opt/etc/xinetd.d/openvpn

	mkdir -p /opt/etc/openvpn/keys
	mkdir -p /opt/etc/openvpn/ccd
	mkdir -p /opt/etc/openvpn/temp
	mkdir -p /opt/etc/openvpn/temp/openvpn

	echo -e "dev tun" 													>> /opt/etc/openvpn/openvpn.conf
	echo -e "" 																>> /opt/etc/openvpn/openvpn.conf
	echo -e "tls-server" 												>> /opt/etc/openvpn/openvpn.conf
	echo -e "server 192.168.255.0 255.255.255.0" 				>> /opt/etc/openvpn/openvpn.conf
	echo -e "ifconfig 192.168.255.1 192.168.255.2" 				>> /opt/etc/openvpn/openvpn.conf
	echo -e "" 																>> /opt/etc/openvpn/openvpn.conf
	echo -e "client-config-dir ccd" 									>> /opt/etc/openvpn/openvpn.conf
	echo -e "" 																>> /opt/etc/openvpn/openvpn.conf
	echo -e "route 192.168.255.0 255.255.255.0" 					>> /opt/etc/openvpn/openvpn.conf
	echo -e "route 192.168.2.0 255.255.255.0" 					>> /opt/etc/openvpn/openvpn.conf
	echo -e "route 192.168.3.0 255.255.255.0" 					>> /opt/etc/openvpn/openvpn.conf
	echo -e "route 192.168.4.0 255.255.255.0" 					>> /opt/etc/openvpn/openvpn.conf
	echo -e "" 																>> /opt/etc/openvpn/openvpn.conf
	echo -e "push \"route $iplan_ad $masklan\"" 					>> /opt/etc/openvpn/openvpn.conf
	echo -e "#push \"route 192.168.2.0 $masklan\"" 				>> /opt/etc/openvpn/openvpn.conf
	echo -e "#push \"route 192.168.3.0 $masklan\"" 				>> /opt/etc/openvpn/openvpn.conf
	echo -e "#push \"route 192.168.4.0 $masklan\"" 				>> /opt/etc/openvpn/openvpn.conf
	echo -e "#push \"route 192.168.5.0 $masklan\"" 				>> /opt/etc/openvpn/openvpn.conf
	echo -e "" 																>> /opt/etc/openvpn/openvpn.conf
	echo -e "dh /opt/etc/openvpn/keys/dh1024.pem" 				>> /opt/etc/openvpn/openvpn.conf
	echo -e "ca /opt/etc/openvpn/keys/ca.crt" 					>> /opt/etc/openvpn/openvpn.conf
	echo -e "cert /opt/etc/openvpn/keys/bserver.crt" 			>> /opt/etc/openvpn/openvpn.conf
	echo -e "key /opt/etc/openvpn/keys/bserver.key" 			>> /opt/etc/openvpn/openvpn.conf
	echo -e "" 																>> /opt/etc/openvpn/openvpn.conf
	echo -e "client-to-client" 										>> /opt/etc/openvpn/openvpn.conf
	echo -e "" 																>> /opt/etc/openvpn/openvpn.conf
	echo -e "port $port_openvpn" 										>> /opt/etc/openvpn/openvpn.conf
	echo -e "proto udp" 													>> /opt/etc/openvpn/openvpn.conf
	echo -e "" 																>> /opt/etc/openvpn/openvpn.conf
	echo -e "user nobody" 												>> /opt/etc/openvpn/openvpn.conf
	echo -e "group nobody" 												>> /opt/etc/openvpn/openvpn.conf
	echo -e "" 																>> /opt/etc/openvpn/openvpn.conf
	echo -e "comp-lzo" 													>> /opt/etc/openvpn/openvpn.conf
	echo -e "persist-tun" 												>> /opt/etc/openvpn/openvpn.conf
	echo -e "persist-key" 												>> /opt/etc/openvpn/openvpn.conf
	echo -e "verb 3" 														>> /opt/etc/openvpn/openvpn.conf
	echo -e "" 																>> /opt/etc/openvpn/openvpn.conf
	echo -e "log-append /opt/var/log/openvpn/openvpn.log" 	>> /opt/etc/openvpn/openvpn.conf
	echo -e "status /opt/var/log/openvpn/status.log" 			>> /opt/etc/openvpn/openvpn.conf
	echo -e "" 																>> /opt/etc/openvpn/openvpn.conf
	echo -e "keepalive 10 60" 											>> /opt/etc/openvpn/openvpn.conf

	# Копирование настроек для клиента	
	echo -e "client" 														>> /opt/etc/openvpn/temp/openvpn/openvpn.conf
	echo -e "" 																>> /opt/etc/openvpn/temp/openvpn/openvpn.conf
	echo -e "pull" 														>> /opt/etc/openvpn/temp/openvpn/openvpn.conf
	echo -e "" 																>> /opt/etc/openvpn/temp/openvpn/openvpn.conf
	echo -e "tls-client" 												>> /opt/etc/openvpn/temp/openvpn/openvpn.conf
	echo -e "dev tun" 													>> /opt/etc/openvpn/temp/openvpn/openvpn.conf
	echo -e "proto udp" 													>> /opt/etc/openvpn/temp/openvpn/openvpn.conf
	echo -e "remote $adr_openvnp $port_openvpn"					>> /opt/etc/openvpn/temp/openvpn/openvpn.conf
	echo -e "resolv-retry infinite" 									>> /opt/etc/openvpn/temp/openvpn/openvpn.conf
	echo -e "nobind" 														>> /opt/etc/openvpn/temp/openvpn/openvpn.conf
	echo -e "persist-key" 												>> /opt/etc/openvpn/temp/openvpn/openvpn.conf
	echo -e "persist-tun" 												>> /opt/etc/openvpn/temp/openvpn/openvpn.conf
	echo -e "ca /opt/etc/openvpn/keys/ca.crt" 					>> /opt/etc/openvpn/temp/openvpn/openvpn.conf
	echo -e "cert /opt/etc/openvpn/keys/c03.crt" 				>> /opt/etc/openvpn/temp/openvpn/openvpn.conf
	echo -e "key /opt/etc/openvpn/keys/c03.key" 					>> /opt/etc/openvpn/temp/openvpn/openvpn.conf
	echo -e "ns-cert-type server" 									>> /opt/etc/openvpn/temp/openvpn/openvpn.conf
	echo -e "comp-lzo" 													>> /opt/etc/openvpn/temp/openvpn/openvpn.conf
	echo -e "verb 3" 														>> /opt/etc/openvpn/temp/openvpn/openvpn.conf
	echo -e "log-append /opt/var/log/openvpn/openvpn.log" 	>> /opt/etc/openvpn/temp/openvpn/openvpn.conf
	echo -e "status /opt/var/log/openvpn/status.log" 			>> /opt/etc/openvpn/temp/openvpn/openvpn.conf

	#  Compress the current subdirectory (tar.gz)
	cd /opt/etc/openvpn/temp
	tar czf client2.tar.gz openvpn
	#rm  -rf /opt/etc/openvpn/clients/openvpn

	# Кусок отправки по почте
	#echo Sending snapshot $1... >  /opt/usr/local/bb-send.log
	#su - $rootname -c "cat /opt/usr/local/header.txt > /opt/usr/local/mail.txt"
	#su - $rootname -c "openssl enc -base64 -in $1 -e >> /opt/usr/local/mail.txt"
	#sendmail -H 'exec openssl s_client -quiet -tls1 -starttls smtp -connect smtp.gmail.com:25' < /opt/usr/local/mail.txt -au<ящик на гугл мейл> -ap<пароль от ящика> <куда шлем> -f <от кого шлем>
	#
	##--- header.txt
	#Subject: Оповещение о дивжении
	#MIME-Version: 1.0
	#Content-Description: "Base64 encode of jpeg snapshat  by Wincode 2.7.3"
	#Content-Type: image/jpeg; name="snapshot.jpg"
	#Content-Transfer-Encoding: Base64
	#Content-Disposition: attachment; filename="snapshot.jpg"


	echo -e "# openvpn Server" 																				>> /tmp/local/sbin/post-firewall
	echo -e "iptables -I INPUT -p udp --dport $port_openvpn -j ACCEPT #only Server (delete for Client)" >> /tmp/local/sbin/post-firewall
	echo -e "iptables -I FORWARD -i br0 -o tun0 -j ACCEPT" 											>> /tmp/local/sbin/post-firewall
	echo -e "iptables -I FORWARD -i tun0 -o br0 -j ACCEPT" 											>> /tmp/local/sbin/post-firewall
	echo -e "iptables -I INPUT -i tun0 -p tcp --dport 80 -j ACCEPT" 								>> /tmp/local/sbin/post-firewall
	echo -e "iptables -I INPUT -i tun0 -p tcp --dport $(nvram get http_lanport) -j ACCEPT"	>> /tmp/local/sbin/post-firewall
	echo -e "iptables -I INPUT -i tun0 -p tcp --dport 139 -j ACCEPT" 								>> /tmp/local/sbin/post-firewall
	echo -e "iptables -I INPUT -i tun0 -p tcp --dport 445 -j ACCEPT" 								>> /tmp/local/sbin/post-firewall
	echo -e "iptables -I INPUT -i tun0 -p udp --dport 137 -j ACCEPT" 								>> /tmp/local/sbin/post-firewall
	echo -e "iptables -I INPUT -i tun0 -p udp --dport 138 -j ACCEPT" 								>> /tmp/local/sbin/post-firewall
	echo -e "iptables -I INPUT -i tun0 -p tcp --dport 901 -j ACCEPT" 								>> /tmp/local/sbin/post-firewall
	echo -e "#iptables -I INPUT -i tun0 -p tcp --dport 9100 -j ACCEPT #printer" 				>> /tmp/local/sbin/post-firewall
	echo -e ""																										>> /tmp/local/sbin/post-firewall

	wget $repaddress_url/S20openvpn -O /opt/etc/init.d/S20openvpn

	if [ $veros = 2.6 ] ; then
		sed -i "s|tun.o|tun|" /opt/etc/init.d/S20openvpn
	fi

#это у тебя файлы с правами для группы/остальных. Небезопасно хранишь ключи. Сделай 
#chmod go-rwx *.key

# http://www.sergeysl.ru/freebsd-openvpn-x509/
fi
#----------------------------------------------------------------------------
if [  "$mv_bcp" = "x"  ]; then

	echo -e "$a_white $INSTAL $a_green Backup for Gmail.com $a_white ...$a_std"

	ipkg install perl-io-socket-ssl
	ipkg install p7zip

	#В файле /opt/lib/perl5/5.8.8/mipsel-linux/Config.pm производим замену параметров 
	sed -i "s|^    libpth => undef,|    libpth => '/usr/lib /lib /opt/lib /opt/usr/lib',	# libpth => undef, |" /opt/lib/perl5/5.8.8/mipsel-linux/Config.pm

	rm -rf /opt/share/backup
	mkdir /opt/share/backup
	mkdir /opt/share/backup/files

	echo "/opt/share/www" 				>> /opt/share/backup/arch
	echo "/opt/var/lib/mysql" 			>> /opt/share/backup/arch
	echo "/opt/etc" 						>> /opt/share/backup/arch
	echo "/tmp/local" 					>> /opt/share/backup/arch
#	echo "/opt/share/www/forum" 		>> /opt/share/backup/arch
#	echo "/opt/etc/mc/mc.menu" 		>> /opt/share/backup/arch

	echo "*.nup" 					>> /opt/share/backup/excl
	echo "*.mp3" 					>> /opt/share/backup/excl
	echo "base.tar" 				>> /opt/share/backup/excl
	echo "*.crt" 					>> /opt/share/backup/excl
	echo "*.key" 					>> /opt/share/backup/excl
	echo "*.pem" 					>> /opt/share/backup/excl

	wget $repaddress_url/sendEmail -O /opt/share/backup/sendEmail
	chmod +x /opt/share/backup/sendEmail

	echo -e "#!/opt/bin/bash"																					>> /opt/share/backup/backup.sh
	echo -e ""																										>> /opt/share/backup/backup.sh
	echo -e "MAIL=\"$gmail_uw@gmail.com\""																	>> /opt/share/backup/backup.sh
	echo -e "THEME=\"Backup ($hname) \""																	>> /opt/share/backup/backup.sh
	echo -e "PASSW=\"$gmail_pw\""																				>> /opt/share/backup/backup.sh
	echo -e "DATA=\`date \"+%d.%m.%Y-%H.%M.%S\"\`"														>> /opt/share/backup/backup.sh
	echo -e "PHONE=\"$phone\""																					>> /opt/share/backup/backup.sh
	echo -e ""																										>> /opt/share/backup/backup.sh
	echo -e "7za a -mx3 -xr@/opt/share/backup/excl -v15m /opt/share/backup/files/www.\$DATA.7z @/opt/share/backup/arch 2>/opt/share/backup/archerr | grep -v '^Compressing' | sed '/^$/d' | more >/opt/share/backup/msg"	>> /opt/share/backup/backup.sh
	echo -e ""																										>> /opt/share/backup/backup.sh
	echo -e "if [[ -s /opt/share/backup/archerr ]];	then"												>> /opt/share/backup/backup.sh
	echo -e "	/opt/etc/sms_py/sendtime.py 8 22 \$PHONE \"Backup archiving error\""			>> /opt/share/backup/backup.sh
	echo -e "else"																									>> /opt/share/backup/backup.sh
	echo -e "	for file in /opt/share/backup/files/*.*; do"											>> /opt/share/backup/backup.sh
	echo -e "		/opt/share/backup/sendEmail -f \$MAIL -t \$MAIL -o message-charset=utf-8 -u \$THEME\$file -o message-format=text/html -o message-file=/opt/share/backup/msg -a \$file -s smtp.gmail.com -o tls=yes -xu \$MAIL -xp \$PASSW 2>/opt/share/backup/senderr 1>/dev/null"	>> /opt/share/backup/backup.sh
	echo -e "		if [[ -s /opt/share/backup/senderr ]]; then"										>> /opt/share/backup/backup.sh
	echo -e "			/opt/etc/sms_py/sendtime.py 8 22 \$PHONE \"Backup mailing error\""	>> /opt/share/backup/backup.sh
	echo -e "		else"																							>> /opt/share/backup/backup.sh
	echo -e "			rm -f \$file"																			>> /opt/share/backup/backup.sh
	echo -e "		fi"																							>> /opt/share/backup/backup.sh
	echo -e "	done"																								>> /opt/share/backup/backup.sh
	echo -e "fi"																									>> /opt/share/backup/backup.sh

	chmod +x /opt/share/backup/backup.sh
	cp /opt/share/backup/backup.sh /opt/etc/cron.weekly/backup.sh

	# http://bruteforcer.ru/index.php/2010/02/01/avtomaticheskoe-rezervnoe-kopirovanie-bloga-na-wordpress-sredstvami-plagina-wordpress-database-backup-ftp-klienta-lftp-i-routera-asus-wl-500gp/
fi

#------------------ Installing NTP Server  ---------------------
# сформирован форумчанином  "Pasha_ZZZ"
if [  "$mv_ntp" = "x"  ]; then
	echo
	echo -e "$a_white $INSTAL $a_green NTP Server (ntpd)$a_white ...$a_std"
	ipkg install ntp
	echo
	echo "Configuring NTP Server for zone RU"
	rm -f /opt/etc/ntp/ntp.conf
	echo "# Conf file for ntpd"						>> /opt/etc/ntp/ntp.conf
	echo ""													>> /opt/etc/ntp/ntp.conf
	echo -e "driftfile /var/spool/ntp/ntp.drift"	>> /opt/etc/ntp/ntp.conf
	echo ""													>> /opt/etc/ntp/ntp.conf
	echo "server 0.ru.pool.ntp.org"			>> /opt/etc/ntp/ntp.conf
	echo "server 1.ru.pool.ntp.org"			>> /opt/etc/ntp/ntp.conf
	echo "server 2.ru.pool.ntp.org"			>> /opt/etc/ntp/ntp.conf
	echo ""											>> /opt/etc/ntp/ntp.conf
	echo "# port for NTP Server"													>> /usr/local/sbin/post-firewall
	if [  "$v_inte" = "YES"  ] ; then
		echo "iptables -I INPUT -p udp -m udp --dport 123 -j ACCEPT"	>> /usr/local/sbin/post-firewall
	else
		echo "# iptables -I INPUT -p udp -m udp --dport 123 -j ACCEPT"	>> /usr/local/sbin/post-firewall
	fi
	echo "" 																				>> /usr/local/sbin/post-firewall
fi
#----------------------------------------------------------------------------
#if [  "$mv_pld" = "x"  ]; then
# 	if [ -z "`ipkg list_installed | grep -w "python"`" ]; then
#		ipkg install python     
# 	fi
#	ipkg install py25-crypto
#	ipkg install py25-curl
#	ipkg install py25-openssl
#	ipkg install py25-pil
#	ipkg install py25-django
#	ipkg install libcurl
# 	if [ -z "`ipkg list_installed | grep -w "sqlite"`" ]; then
#		ipkg install sqlite      
#	fi
#	ipkg install tesseract-ocr
#	ipkg install unzip
# 	if [ -z "`ipkg list_installed | grep -w "screen"`" ]; then
#		ipkg install screen     
#	fi
# 	if [ -z "`ipkg list_installed | grep -w "nano"`" ]; then
#		ipkg install nano       
#	fi
# 	if [ -z "`ipkg list_installed | grep -w "wget-ssl"`" ]; then
#		ipkg install wget-ssl    
#	fi
#	cd /opt
#
#	wget  http://get.pyload.org/get/src/
#	unzip pyload-src-v0.4.6.zip
#fi

#****************************************************************************
#                  END PROGRAM
#****************************************************************************
stop_srv
if [ "$v_lan" = "RU" ]; then echo  -e "$a_red Удаление$a_white временных файлов ...$a_std"; else "$a_red Delete$a_white install script ...$a_std"; fi 

rm -f /tmp/local/root/*.sh
rm -f /tmp/local/root/*.shm   # Удаление "Дочерних" скриптов
rm -f /tmp/local/root/parttable*
rm -f /tmp/local/root/*.gz
rm -f /tmp/local/root/*.tgz
rm -f /tmp/local/root/*.ipk
rm -f /opt/tmp/ipkg/*.*
rm -f /tmp/local/root/send.php
rm -f /tmp/local/root/.mc/history  ## Удаляем дабы  не сохранять
rm -f /tmp/local/root/.cedit        # мусор перед flash save
tput clear
echo ; echo ; echo ; echo ; echo ; echo ; echo ; echo
if [ "$v_lan" = "RU" ]; then
	echo -e "                      $a_green Установка завершена!$a_std"
	echo -e "                      Роутер перезагружается ..."
else
	echo -e "                      $a_green Wait for$a_red REBOOT$a_white ...$a_std"
	echo -e "                      $a_green Installation << OK >>$a_std"
fi

echo -e "$a_bell"
sleep 10

flashfs save && flashfs commit && flashfs enable && reboot
#  END 

# ПЛАНЫ 
#
#ipkg install vsftpd    http://wl500g.info/showpost.php?p=53426&postcount=7
# ipkg install optware-devel
#mkdir /opt/source/vsftpd-2.0.5.ext3.3
#cd /opt/source/vsftpd-2.0.5.ext3.3
#wget http://vsftpd.devnet.ru/files/2.0.5/....ext3.3.tar.gz
#tar -xzvf ./vsftpd-2.0.5.ext3.3.tar.gz

#nvram set sdram_init=0x0011
#nvram set sdram_config=0x0062
#nvram set sdram_ncdl=0
#nvram set clkfreq=300,150
#nvram commit

#Заводские настройки
#для 500gp-v.1 дать команды
#erase /dev/mtd/3
#erase /dev/mtd/4

#		echo -e "░ ▒ ▓ │ ┤ ╡ ╢ ╖ ╕ ╣ ║ ╗ ╝ ╜ ╛ ┐"
#		echo -e "└ ┴ ┬ ├ ─ ┼ ╞ ╟ ╚ ╔ ╩ ╦ ╠ ═ ╬ ╧"
#		echo -e "╨ ╤ ╥ ╙ ╘ ╒ ╓ ╫ ╪ ┘ ┌ █ ▄ ▌ ▐ ▀"
